/* 
 * Command line: opannotate --source 
 * 
 * Interpretation of command line:
 * Output annotated source file with samples
 * Output all files
 * 
 * CPU: Intel Ivy Bridge microarchitecture, speed 2600 MHz (estimated)
 * Counted CPU_CLK_UNHALTED events (Clock cycles when not halted) with a unit mask of 0x00 (No unit mask) count 1000000
 */
/* 
 * Total samples for file : "/home/bukatlib/Benchmarks/code_optimization/triag_impr2.cpp"
 * 
 * 230625 82.0546
 */


               :#include <algorithm>
               :#include <array>
               :#include <chrono>
               :#include <cmath>
               :#include <cstdlib>
               :#include <iomanip>
               :#include <iostream>
               :#include <limits>
               :#include <fstream>
               :#include <random>
               :#include <string>
               :#include <stdexcept>
               :#include <queue>
               :#include <tuple>
               :#include <vector>
               :#include <stdint.h>
               :
               :using namespace std;
               :using namespace std::chrono;
               :
               :struct Point {
               :	float x, y;
               :};
               :
               :#pragma omp declare simd notinbranch
               :float dist(const Point& p1, const Point& p2) {
   570  0.2028 :	return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
               :}
               :
               :#pragma omp declare simd notinbranch
               :float cost(const vector<Point>& points, int i, int j, int k) {
               :	const Point& p1 = points[i],& p2 = points[j],& p3 = points[k];
               :	return dist(p1, p2)+dist(p2, p3)+dist(p3, p1);
               :}
               :
               :vector<tuple<int, int, int>> findTriangles(const vector<Point>& points, const vector<vector<float>>& table)	{ /* findTriangles(std::vector<Point, std::allocator<Point> > const&, std::vector<std::vector<float, std::allocator<float> >, std::allocator<std::vector<float, std::allocator<float> > > > const&) total:      6  0.0021 */
               :	size_t n = table.size();
               :	vector<tuple<int, int, int>> triangles;
               :	queue<tuple<int,int>> toResove;
               :	toResove.emplace(0, n-1);
               :
               :	while (!toResove.empty())	{
               :		int i, j;
               :		tie(i, j) = toResove.front();
               :		toResove.pop();
               :
               :		int k = i+1;
               :		float distIJ = dist(points[i], points[j]);
               :		float minDiff = numeric_limits<float>::max();
     2 7.1e-04 :		for (int l = i+1; l < j; l++)	{
               :			float dist1 = dist(points[i], points[l]), dist2 = dist(points[j], points[l]);
               :			float triagCost = table[i][l]+table[j][l]+cost(points, i, j, l)-dist1-dist2;
               :			float diff = abs(table[i][j]-distIJ-triagCost);
               :			if (diff < minDiff)	{
     1 3.6e-04 :				minDiff = diff;
               :				k = l;
               :			}
               :		}
               :
               :		triangles.emplace_back(i, k, j);
               :		if (j > k+1)
               :			toResove.emplace(k, j);
               :		if (k > i+1)
               :			toResove.emplace(i, k);
               :	}
               :
               :	return triangles;
               :}
               :
               :tuple<vector<tuple<int, int, int>>, float> triangulate(vector<Point> points) { /* triangulate(std::vector<Point, std::allocator<Point> >) total:      2 7.1e-04 */
               :
               :	uint32_t n = points.size();
               :	if (n < 3)
               :		return make_tuple(vector<tuple<int,int,int>>(), 0.0f);
               :
               :	vector<vector<float>> table(n, vector<float>(n, 0.0f));
               :
               :	// Fill initial line lengths.
               :	for (int i = 0; i+1 < n; ++i)
     2 7.1e-04 :		table[i][i+1] = table[i+1][i] = dist(points[i], points[i+1]);
               :
               :	for (int gap = 2; gap < n; gap++) {
   156  0.0555 :		#pragma omp parallel for schedule(static) /* triangulate(std::vector<Point, std::allocator<Point> >) [clone ._omp_fn.0] total: 230677 82.0731 */
    28  0.0100 :		for (int j = gap; j < n; ++j)	{
               :
               :			int i = j-gap;
               :			float bestCost = numeric_limits<float>::max();
               :
   273  0.0971 :			#pragma omp simd reduction(min:bestCost)
   678  0.2412 :			for (int k = i+1; k < j; k++)
228646 81.3504 :				bestCost = min(bestCost, table[i][k]+table[j][k]);
               :
               :			// Update for the next iteration.
               :			float distIJ = dist(points[i], points[j]);
   269  0.0957 :			table[i][j] = table[j][i] = bestCost+2.0f*distIJ;
               :		}
               :	}
               :
               :	// Find the triangles...
               :	float bestCost = table[0][n-1]-dist(points[0],points[n-1]);
               :	vector<tuple<int,int,int>> triangles = findTriangles(points, table);
               :	return make_tuple(move(triangles), bestCost);
               :}
               :
               :vector<Point> generatePoints(uint32_t n)	{
               :	constexpr float pi = 3.141592653589;
               :	float step = 2*pi/n;
               :	vector<Point> points;
               :	for (uint32_t i = 0; i < n; ++i)	{
               :		float angle = step*i;
               :		points.push_back({800.0f*cosf(angle)+800.0f, 800.0f*sinf(angle)+800.0f});
               :	}
               :
               :	return points;
               :}
               :
               :vector<Point> readProblem(const string& inputFile)	{
               :	vector<Point> points;
               :	ifstream bin(inputFile.c_str(), ifstream::binary);
               :	if (bin)	{
               :		int32_t n = 0;
               :		bin.read((char*) &n, sizeof(int32_t));
               :		for (uint64_t p = 0; p < n; ++p)	{
               :			float x = 0.0, y = 0.0;
               :			bin.read((char*) &x, sizeof(float));
               :			bin.read((char*) &y, sizeof(float));
               :			points.push_back({x, y});
               :		}
               :
               :		bin.close();
               :	} else {
               :		throw invalid_argument("Cannot open the input file '"+inputFile+"' to read the problem.");
               :	}
               :
               :	return points;
               :}
               :
               :void writeResult(float triagCost, const vector<tuple<int, int, int>>& triangles, const string& resultFile)	{
               :	ofstream bout(resultFile.c_str(), ofstream::binary | ofstream::trunc);
               :	if (bout)	{
               :		bout.write((char*) &triagCost, sizeof(float));
               :		for (const auto& triangle : triangles)	{
               :			int32_t p1, p2, p3;
               :			tie(p1, p2, p3) = triangle;
               :			bout.write((char*) &p1, sizeof(int32_t));
               :			bout.write((char*) &p2, sizeof(int32_t));
               :			bout.write((char*) &p3, sizeof(int32_t));
               :		}
               :
               :		bout.close();
               :	} else {
               :		throw invalid_argument("Cannot write the results, check the permissions.");
               :	}
               :}
               :
               :void writeImage(const vector<Point>& points, const vector<tuple<int, int, int>>& triangles, const string& imageFilename)	{
               :	constexpr uint32_t numOfColors = 10;
               :	array<string, numOfColors> colors = {
               :		"orange", "brown", "purple", "blue", "darksalmon", "yellow", "green", "red", "lime", "aqua"
               :	};
               :
               :	float minX = 10e6, maxX = -10e6, minY = 10e6, maxY = -10e6;
               :	for (const Point& p : points)	{
               :		minX = min(minX, p.x);
               :		maxX = max(maxX, p.x);
               :		minY = min(minY, p.y);
               :		maxY = max(maxY, p.y);
               :	}
               :
               :	float mult = 1600.0f/(maxX-minX), height = ceil(mult*(maxY-minY));
               :
               :	ofstream im(imageFilename);
               :	if (im)	{
               :		im<<"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"1600\" height=\""<<height<<"\">"<<endl;
               :
               :		default_random_engine generator;
               :		uniform_int_distribution<uint32_t> colorIdx(0u, numOfColors-1u);
               :		for (const tuple<int, int, int>& t : triangles)	{
               :			int i, j, k;
               :			tie(i, j, k) = t;
               :
               :			array<Point, 3> p { points[i], points[j], points[k] };
               :			for (uint32_t i = 0; i < 3; ++i)	{
               :				p[i].x = mult*(p[i].x-minX);
               :				p[i].y = mult*(p[i].y-minY);
               :			}
               :
               :			im<<"\t<polygon points=\""<<p[0].x<<","<<p[0].y<<" "<<p[1].x<<","<<p[1].y<<" "<<p[2].x<<","<<p[2].y<<"\" ";
               :			im<<"style=\"fill:"<<colors[colorIdx(generator)]<<";stroke:black;stroke-width=0.3\"/>"<<endl;
               :		}
               :
               :		for (uint32_t i = 0; i < points.size(); ++i)	{
               :			array<Point, 2> p { points[i % points.size()], points[(i+1) % points.size()] };
               :			for (uint32_t i = 0; i < 2; ++i)	{
               :				p[i].x = mult*(p[i].x-minX);
               :				p[i].y = mult*(p[i].y-minY);
               :			}	
               :
               :			im<<"\t<line x1=\""<<p[0].x<<"\" y1=\""<<p[0].y<<"\" x2=\""<<p[1].x<<"\" y2=\""<<p[1].y<<"\" ";
               :			im<<"stroke-width=\"2\" stroke=\"black\"/>"<<endl;
               :		}
               :
               :		im<<"</svg>"<<endl;
               :		im.close();
               :	} else {
               :		cerr<<"Cannot write the result to svg file!"<<endl;
               :	}
               :}
               :
               :int main(int argc, char* argv[]) {
               :	uint32_t numberOfPoints = 32u;
               :	string imageFilename, inputFile, resultFile;
               :	for (int i = 1; i < argc; ++i)	{
               :		string parg = argv[i];
               :		if (parg == "--help" || parg == "-h")	{
               :			cout<<"Triangulation of a convex polygon."<<endl;
               :			cout<<endl<<"Usage:"<<endl;
               :			cout<<"\t"<<argv[0]<<" input_problem.bin result.bin [options]"<<endl<<endl;
               :			cout<<"General options:"<<endl;
               :			cout<<"\t--output-image ARG, -of ARG, ARG: {FILE_NAME}.svg"<<endl;
               :			cout<<"\t\tThe output svg file demonstrating the triangulation."<<endl;
               :			cout<<"\t--help, -h"<<endl;
               :			cout<<"\t\tIt prints this help."<<endl;
               :			return 0;
               :		}
               :
               :		if (parg == "--output-image" || parg == "-of")	{
               :			if (i+1 < argc)	{
               :				imageFilename = argv[++i];
               :			} else {
               :				cerr<<"Expected a filename for the output image!"<<endl;
               :				return 1;
               :			}
               :		}
               :
               :		if (!parg.empty() && parg[0] != '-')	{
               :			if (inputFile.empty())
               :				inputFile = parg;
               :			else
               :				resultFile = parg;
               :		}
               :	}
               :
               :	try {
               :		high_resolution_clock::time_point start = high_resolution_clock::now();
               :
               :		float criterion;
               :		vector<tuple<int, int, int>> triangles;
               :		const vector<Point>& points = readProblem(inputFile);
               :
               :		tie(triangles, criterion) = triangulate(points);
               :		double totalDuration = duration_cast<duration<double>>(high_resolution_clock::now()-start).count();
               :
               :		if (!resultFile.empty())
               :			writeResult(criterion, triangles, resultFile);
               :
               :		if (!imageFilename.empty())
               :			writeImage(points, triangles, imageFilename);
               :
               :		cout<<"Cost of triangulation: "<<criterion<<endl;
               :		cout<<"computational time: "<<totalDuration<<" s"<<endl;
               :
               :	} catch (exception& e) {
               :		cerr<<"Exception caught: "<<e.what()<<endl;
               :		return 2;
               :	}
               :
               :	return 0;
               :}
               :
/* 
 * Total samples for file : "/usr/lib/gcc/x86_64-pc-linux-gnu/4.9.3/include/g++-v4/cmath"
 * 
 *     46  0.0164
 */


               :// -*- C++ -*- C forwarding header.
               :
               :// Copyright (C) 1997-2014 Free Software Foundation, Inc.
               ://
               :// This file is part of the GNU ISO C++ Library.  This library is free
               :// software; you can redistribute it and/or modify it under the
               :// terms of the GNU General Public License as published by the
               :// Free Software Foundation; either version 3, or (at your option)
               :// any later version.
               :
               :// This library is distributed in the hope that it will be useful,
               :// but WITHOUT ANY WARRANTY; without even the implied warranty of
               :// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
               :// GNU General Public License for more details.
               :
               :// Under Section 7 of GPL version 3, you are granted additional
               :// permissions described in the GCC Runtime Library Exception, version
               :// 3.1, as published by the Free Software Foundation.
               :
               :// You should have received a copy of the GNU General Public License and
               :// a copy of the GCC Runtime Library Exception along with this program;
               :// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
               :// <http://www.gnu.org/licenses/>.
               :
               :/** @file include/cmath
               : *  This is a Standard C++ Library file.  You should @c \#include this file
               : *  in your programs, rather than any of the @a *.h implementation files.
               : *
               : *  This is the C++ version of the Standard C Library header @c math.h,
               : *  and its contents are (mostly) the same as that header, but are all
               : *  contained in the namespace @c std (except for names which are defined
               : *  as macros in C).
               : */
               :
               ://
               :// ISO C++ 14882: 26.5  C library
               ://
               :
               :#pragma GCC system_header
               :
               :#include <bits/c++config.h>
               :#include <bits/cpp_type_traits.h>
               :#include <ext/type_traits.h>
               :#include <math.h>
               :
               :#ifndef _GLIBCXX_CMATH
               :#define _GLIBCXX_CMATH 1
               :
               :// Get rid of those macros defined in <math.h> in lieu of real functions.
               :#undef abs
               :#undef div
               :#undef acos
               :#undef asin
               :#undef atan
               :#undef atan2
               :#undef ceil
               :#undef cos
               :#undef cosh
               :#undef exp
               :#undef fabs
               :#undef floor
               :#undef fmod
               :#undef frexp
               :#undef ldexp
               :#undef log
               :#undef log10
               :#undef modf
               :#undef pow
               :#undef sin
               :#undef sinh
               :#undef sqrt
               :#undef tan
               :#undef tanh
               :
               :namespace std _GLIBCXX_VISIBILITY(default)
               :{
               :_GLIBCXX_BEGIN_NAMESPACE_VERSION
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR double
               :  abs(double __x)
               :  { return __builtin_fabs(__x); }
               :#endif
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  abs(float __x)
               :  { return __builtin_fabsf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  abs(long double __x)
               :  { return __builtin_fabsl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    abs(_Tp __x)
               :    { return __builtin_fabs(__x); }
               :
               :  using ::acos;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  acos(float __x)
               :  { return __builtin_acosf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  acos(long double __x)
               :  { return __builtin_acosl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    acos(_Tp __x)
               :    { return __builtin_acos(__x); }
               :
               :  using ::asin;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  asin(float __x)
               :  { return __builtin_asinf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  asin(long double __x)
               :  { return __builtin_asinl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    asin(_Tp __x)
               :    { return __builtin_asin(__x); }
               :
               :  using ::atan;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  atan(float __x)
               :  { return __builtin_atanf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  atan(long double __x)
               :  { return __builtin_atanl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    atan(_Tp __x)
               :    { return __builtin_atan(__x); }
               :
               :  using ::atan2;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  atan2(float __y, float __x)
               :  { return __builtin_atan2f(__y, __x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  atan2(long double __y, long double __x)
               :  { return __builtin_atan2l(__y, __x); }
               :#endif
               :
               :  template<typename _Tp, typename _Up>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    atan2(_Tp __y, _Up __x)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return atan2(__type(__y), __type(__x));
               :    }
               :
               :  using ::ceil;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  ceil(float __x)
               :  { return __builtin_ceilf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  ceil(long double __x)
               :  { return __builtin_ceill(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    ceil(_Tp __x)
               :    { return __builtin_ceil(__x); }
               :
               :  using ::cos;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  cos(float __x)
               :  { return __builtin_cosf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  cos(long double __x)
               :  { return __builtin_cosl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    cos(_Tp __x)
               :    { return __builtin_cos(__x); }
               :
               :  using ::cosh;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  cosh(float __x)
               :  { return __builtin_coshf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  cosh(long double __x)
               :  { return __builtin_coshl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    cosh(_Tp __x)
               :    { return __builtin_cosh(__x); }
               :
               :  using ::exp;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  exp(float __x)
               :  { return __builtin_expf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  exp(long double __x)
               :  { return __builtin_expl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    exp(_Tp __x)
               :    { return __builtin_exp(__x); }
               :
               :  using ::fabs;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  fabs(float __x)
               :  { return __builtin_fabsf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  fabs(long double __x)
               :  { return __builtin_fabsl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    fabs(_Tp __x)
               :    { return __builtin_fabs(__x); }
               :
               :  using ::floor;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  floor(float __x)
               :  { return __builtin_floorf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  floor(long double __x)
               :  { return __builtin_floorl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    floor(_Tp __x)
               :    { return __builtin_floor(__x); }
               :
               :  using ::fmod;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  fmod(float __x, float __y)
               :  { return __builtin_fmodf(__x, __y); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  fmod(long double __x, long double __y)
               :  { return __builtin_fmodl(__x, __y); }
               :#endif
               :
               :  template<typename _Tp, typename _Up>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    fmod(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return fmod(__type(__x), __type(__y));
               :    }
               :
               :  using ::frexp;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline float
               :  frexp(float __x, int* __exp)
               :  { return __builtin_frexpf(__x, __exp); }
               :
               :  inline long double
               :  frexp(long double __x, int* __exp)
               :  { return __builtin_frexpl(__x, __exp); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    frexp(_Tp __x, int* __exp)
               :    { return __builtin_frexp(__x, __exp); }
               :
               :  using ::ldexp;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  ldexp(float __x, int __exp)
               :  { return __builtin_ldexpf(__x, __exp); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  ldexp(long double __x, int __exp)
               :  { return __builtin_ldexpl(__x, __exp); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    ldexp(_Tp __x, int __exp)
               :    { return __builtin_ldexp(__x, __exp); }
               :
               :  using ::log;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  log(float __x)
               :  { return __builtin_logf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  log(long double __x)
               :  { return __builtin_logl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    log(_Tp __x)
               :    { return __builtin_log(__x); }
               :
               :  using ::log10;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  log10(float __x)
               :  { return __builtin_log10f(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  log10(long double __x)
               :  { return __builtin_log10l(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                    double>::__type
               :    log10(_Tp __x)
               :    { return __builtin_log10(__x); }
               :
               :  using ::modf;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline float
               :  modf(float __x, float* __iptr)
               :  { return __builtin_modff(__x, __iptr); }
               :
               :  inline long double
               :  modf(long double __x, long double* __iptr)
               :  { return __builtin_modfl(__x, __iptr); }
               :#endif
               :
               :  using ::pow;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  pow(float __x, float __y)
               :  { return __builtin_powf(__x, __y); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  pow(long double __x, long double __y)
               :  { return __builtin_powl(__x, __y); }
               :
               :#if __cplusplus < 201103L
               :  // _GLIBCXX_RESOLVE_LIB_DEFECTS
               :  // DR 550. What should the return type of pow(float,int) be?
               :  inline double
               :  pow(double __x, int __i)
               :  { return __builtin_powi(__x, __i); }
               :
               :  inline float
               :  pow(float __x, int __n)
               :  { return __builtin_powif(__x, __n); }
               :
               :  inline long double
               :  pow(long double __x, int __n)
               :  { return __builtin_powil(__x, __n); }
               :#endif
               :#endif
               :
               :  template<typename _Tp, typename _Up>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    pow(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return pow(__type(__x), __type(__y));
               :    }
               :
               :  using ::sin;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  sin(float __x)
               :  { return __builtin_sinf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  sin(long double __x)
               :  { return __builtin_sinl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    sin(_Tp __x)
               :    { return __builtin_sin(__x); }
               :
               :  using ::sinh;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  sinh(float __x)
               :  { return __builtin_sinhf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  sinh(long double __x)
               :  { return __builtin_sinhl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    sinh(_Tp __x)
               :    { return __builtin_sinh(__x); }
               :
               :  using ::sqrt;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  sqrt(float __x)
    46  0.0164 :  { return __builtin_sqrtf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  sqrt(long double __x)
               :  { return __builtin_sqrtl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    sqrt(_Tp __x)
               :    { return __builtin_sqrt(__x); }
               :
               :  using ::tan;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  tan(float __x)
               :  { return __builtin_tanf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  tan(long double __x)
               :  { return __builtin_tanl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    tan(_Tp __x)
               :    { return __builtin_tan(__x); }
               :
               :  using ::tanh;
               :
               :#ifndef __CORRECT_ISO_CPP_MATH_H_PROTO
               :  inline _GLIBCXX_CONSTEXPR float
               :  tanh(float __x)
               :  { return __builtin_tanhf(__x); }
               :
               :  inline _GLIBCXX_CONSTEXPR long double
               :  tanh(long double __x)
               :  { return __builtin_tanhl(__x); }
               :#endif
               :
               :  template<typename _Tp>
               :    inline _GLIBCXX_CONSTEXPR
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    double>::__type
               :    tanh(_Tp __x)
               :    { return __builtin_tanh(__x); }
               :
               :_GLIBCXX_END_NAMESPACE_VERSION
               :} // namespace
               :
               :#if _GLIBCXX_USE_C99_MATH
               :#if !_GLIBCXX_USE_C99_FP_MACROS_DYNAMIC
               :
               :// These are possible macros imported from C99-land.
               :#undef fpclassify
               :#undef isfinite
               :#undef isinf
               :#undef isnan
               :#undef isnormal
               :#undef signbit
               :#undef isgreater
               :#undef isgreaterequal
               :#undef isless
               :#undef islessequal
               :#undef islessgreater
               :#undef isunordered
               :
               :namespace std _GLIBCXX_VISIBILITY(default)
               :{
               :_GLIBCXX_BEGIN_NAMESPACE_VERSION
               :
               :#if __cplusplus >= 201103L
               :  constexpr int
               :  fpclassify(float __x)
               :  { return __builtin_fpclassify(FP_NAN, FP_INFINITE, FP_NORMAL,
               :				FP_SUBNORMAL, FP_ZERO, __x); }
               :
               :  constexpr int
               :  fpclassify(double __x)
               :  { return __builtin_fpclassify(FP_NAN, FP_INFINITE, FP_NORMAL,
               :				FP_SUBNORMAL, FP_ZERO, __x); }
               :
               :  constexpr int
               :  fpclassify(long double __x)
               :  { return __builtin_fpclassify(FP_NAN, FP_INFINITE, FP_NORMAL,
               :				FP_SUBNORMAL, FP_ZERO, __x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                              int>::__type
               :    fpclassify(_Tp __x)
               :    { return __x != 0 ? FP_NORMAL : FP_ZERO; }
               :
               :  constexpr bool
               :  isfinite(float __x)
               :  { return __builtin_isfinite(__x); }
               :
               :  constexpr bool
               :  isfinite(double __x)
               :  { return __builtin_isfinite(__x); }
               :
               :  constexpr bool
               :  isfinite(long double __x)
               :  { return __builtin_isfinite(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                              bool>::__type
               :    isfinite(_Tp __x)
               :    { return true; }
               :
               :  constexpr bool
               :  isinf(float __x)
               :  { return __builtin_isinf(__x); }
               :
               :  constexpr bool
               :  isinf(double __x)
               :  { return __builtin_isinf(__x); }
               :
               :  constexpr bool
               :  isinf(long double __x)
               :  { return __builtin_isinf(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                              bool>::__type
               :    isinf(_Tp __x)
               :    { return false; }
               :
               :  constexpr bool
               :  isnan(float __x)
               :  { return __builtin_isnan(__x); }
               :
               :  constexpr bool
               :  isnan(double __x)
               :  { return __builtin_isnan(__x); }
               :
               :  constexpr bool
               :  isnan(long double __x)
               :  { return __builtin_isnan(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                              bool>::__type
               :    isnan(_Tp __x)
               :    { return false; }
               :
               :  constexpr bool
               :  isnormal(float __x)
               :  { return __builtin_isnormal(__x); }
               :
               :  constexpr bool
               :  isnormal(double __x)
               :  { return __builtin_isnormal(__x); }
               :
               :  constexpr bool
               :  isnormal(long double __x)
               :  { return __builtin_isnormal(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                              bool>::__type
               :    isnormal(_Tp __x)
               :    { return __x != 0 ? true : false; }
               :
               :  // The front-end doesn't provide a type generic builtin (libstdc++/58625).
               :  constexpr bool
               :  signbit(float __x)
               :  { return __builtin_signbitf(__x); }
               :
               :  constexpr bool
               :  signbit(double __x)
               :  { return __builtin_signbit(__x); }
               :
               :  constexpr bool
               :  signbit(long double __x)
               :  { return __builtin_signbitl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value,
               :                                              bool>::__type
               :    signbit(_Tp __x)
               :    { return __x < 0 ? true : false; }
               :
               :  constexpr bool
               :  isgreater(float __x, float __y)
               :  { return __builtin_isgreater(__x, __y); }
               :
               :  constexpr bool
               :  isgreater(double __x, double __y)
               :  { return __builtin_isgreater(__x, __y); }
               :
               :  constexpr bool
               :  isgreater(long double __x, long double __y)
               :  { return __builtin_isgreater(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename
               :    __gnu_cxx::__enable_if<(__is_arithmetic<_Tp>::__value
               :			    && __is_arithmetic<_Up>::__value), bool>::__type
               :    isgreater(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return __builtin_isgreater(__type(__x), __type(__y));
               :    }
               :
               :  constexpr bool
               :  isgreaterequal(float __x, float __y)
               :  { return __builtin_isgreaterequal(__x, __y); }
               :
               :  constexpr bool
               :  isgreaterequal(double __x, double __y)
               :  { return __builtin_isgreaterequal(__x, __y); }
               :
               :  constexpr bool
               :  isgreaterequal(long double __x, long double __y)
               :  { return __builtin_isgreaterequal(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename
               :    __gnu_cxx::__enable_if<(__is_arithmetic<_Tp>::__value
               :			    && __is_arithmetic<_Up>::__value), bool>::__type
               :    isgreaterequal(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return __builtin_isgreaterequal(__type(__x), __type(__y));
               :    }
               :
               :  constexpr bool
               :  isless(float __x, float __y)
               :  { return __builtin_isless(__x, __y); }
               :
               :  constexpr bool
               :  isless(double __x, double __y)
               :  { return __builtin_isless(__x, __y); }
               :
               :  constexpr bool
               :  isless(long double __x, long double __y)
               :  { return __builtin_isless(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename
               :    __gnu_cxx::__enable_if<(__is_arithmetic<_Tp>::__value
               :			    && __is_arithmetic<_Up>::__value), bool>::__type
               :    isless(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return __builtin_isless(__type(__x), __type(__y));
               :    }
               :
               :  constexpr bool
               :  islessequal(float __x, float __y)
               :  { return __builtin_islessequal(__x, __y); }
               :
               :  constexpr bool
               :  islessequal(double __x, double __y)
               :  { return __builtin_islessequal(__x, __y); }
               :
               :  constexpr bool
               :  islessequal(long double __x, long double __y)
               :  { return __builtin_islessequal(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename
               :    __gnu_cxx::__enable_if<(__is_arithmetic<_Tp>::__value
               :			    && __is_arithmetic<_Up>::__value), bool>::__type
               :    islessequal(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return __builtin_islessequal(__type(__x), __type(__y));
               :    }
               :
               :  constexpr bool
               :  islessgreater(float __x, float __y)
               :  { return __builtin_islessgreater(__x, __y); }
               :
               :  constexpr bool
               :  islessgreater(double __x, double __y)
               :  { return __builtin_islessgreater(__x, __y); }
               :
               :  constexpr bool
               :  islessgreater(long double __x, long double __y)
               :  { return __builtin_islessgreater(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename
               :    __gnu_cxx::__enable_if<(__is_arithmetic<_Tp>::__value
               :			    && __is_arithmetic<_Up>::__value), bool>::__type
               :    islessgreater(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return __builtin_islessgreater(__type(__x), __type(__y));
               :    }
               :
               :  constexpr bool
               :  isunordered(float __x, float __y)
               :  { return __builtin_isunordered(__x, __y); }
               :
               :  constexpr bool
               :  isunordered(double __x, double __y)
               :  { return __builtin_isunordered(__x, __y); }
               :
               :  constexpr bool
               :  isunordered(long double __x, long double __y)
               :  { return __builtin_isunordered(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename
               :    __gnu_cxx::__enable_if<(__is_arithmetic<_Tp>::__value
               :			    && __is_arithmetic<_Up>::__value), bool>::__type
               :    isunordered(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return __builtin_isunordered(__type(__x), __type(__y));
               :    }
               :
               :#else
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    fpclassify(_Tp __f)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_fpclassify(FP_NAN, FP_INFINITE, FP_NORMAL,
               :				  FP_SUBNORMAL, FP_ZERO, __type(__f));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    isfinite(_Tp __f)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_isfinite(__type(__f));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    isinf(_Tp __f)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_isinf(__type(__f));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    isnan(_Tp __f)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_isnan(__type(__f));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    isnormal(_Tp __f)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_isnormal(__type(__f));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    signbit(_Tp __f)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_signbit(__type(__f));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    isgreater(_Tp __f1, _Tp __f2)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_isgreater(__type(__f1), __type(__f2));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    isgreaterequal(_Tp __f1, _Tp __f2)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_isgreaterequal(__type(__f1), __type(__f2));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    isless(_Tp __f1, _Tp __f2)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_isless(__type(__f1), __type(__f2));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    islessequal(_Tp __f1, _Tp __f2)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_islessequal(__type(__f1), __type(__f2));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    islessgreater(_Tp __f1, _Tp __f2)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_islessgreater(__type(__f1), __type(__f2));
               :    }
               :
               :  template<typename _Tp>
               :    inline typename __gnu_cxx::__enable_if<__is_arithmetic<_Tp>::__value,
               :					   int>::__type
               :    isunordered(_Tp __f1, _Tp __f2)
               :    {
               :      typedef typename __gnu_cxx::__promote<_Tp>::__type __type;
               :      return __builtin_isunordered(__type(__f1), __type(__f2));
               :    }
               :
               :#endif
               :
               :_GLIBCXX_END_NAMESPACE_VERSION
               :} // namespace
               :
               :#endif /* _GLIBCXX_USE_C99_FP_MACROS_DYNAMIC */
               :#endif
               :
               :#if __cplusplus >= 201103L
               :
               :#ifdef _GLIBCXX_USE_C99_MATH_TR1
               :
               :#undef acosh
               :#undef acoshf
               :#undef acoshl
               :#undef asinh
               :#undef asinhf
               :#undef asinhl
               :#undef atanh
               :#undef atanhf
               :#undef atanhl
               :#undef cbrt
               :#undef cbrtf
               :#undef cbrtl
               :#undef copysign
               :#undef copysignf
               :#undef copysignl
               :#undef erf
               :#undef erff
               :#undef erfl
               :#undef erfc
               :#undef erfcf
               :#undef erfcl
               :#undef exp2
               :#undef exp2f
               :#undef exp2l
               :#undef expm1
               :#undef expm1f
               :#undef expm1l
               :#undef fdim
               :#undef fdimf
               :#undef fdiml
               :#undef fma
               :#undef fmaf
               :#undef fmal
               :#undef fmax
               :#undef fmaxf
               :#undef fmaxl
               :#undef fmin
               :#undef fminf
               :#undef fminl
               :#undef hypot
               :#undef hypotf
               :#undef hypotl
               :#undef ilogb
               :#undef ilogbf
               :#undef ilogbl
               :#undef lgamma
               :#undef lgammaf
               :#undef lgammal
               :#undef llrint
               :#undef llrintf
               :#undef llrintl
               :#undef llround
               :#undef llroundf
               :#undef llroundl
               :#undef log1p
               :#undef log1pf
               :#undef log1pl
               :#undef log2
               :#undef log2f
               :#undef log2l
               :#undef logb
               :#undef logbf
               :#undef logbl
               :#undef lrint
               :#undef lrintf
               :#undef lrintl
               :#undef lround
               :#undef lroundf
               :#undef lroundl
               :#undef nan
               :#undef nanf
               :#undef nanl
               :#undef nearbyint
               :#undef nearbyintf
               :#undef nearbyintl
               :#undef nextafter
               :#undef nextafterf
               :#undef nextafterl
               :#undef nexttoward
               :#undef nexttowardf
               :#undef nexttowardl
               :#undef remainder
               :#undef remainderf
               :#undef remainderl
               :#undef remquo
               :#undef remquof
               :#undef remquol
               :#undef rint
               :#undef rintf
               :#undef rintl
               :#undef round
               :#undef roundf
               :#undef roundl
               :#undef scalbln
               :#undef scalblnf
               :#undef scalblnl
               :#undef scalbn
               :#undef scalbnf
               :#undef scalbnl
               :#undef tgamma
               :#undef tgammaf
               :#undef tgammal
               :#undef trunc
               :#undef truncf
               :#undef truncl
               :
               :namespace std _GLIBCXX_VISIBILITY(default)
               :{
               :_GLIBCXX_BEGIN_NAMESPACE_VERSION
               :
               :  // types
               :  using ::double_t;
               :  using ::float_t;
               :
               :  // functions
               :  using ::acosh;
               :  using ::acoshf;
               :  using ::acoshl;
               :
               :  using ::asinh;
               :  using ::asinhf;
               :  using ::asinhl;
               :
               :  using ::atanh;
               :  using ::atanhf;
               :  using ::atanhl;
               :
               :  using ::cbrt;
               :  using ::cbrtf;
               :  using ::cbrtl;
               :
               :  using ::copysign;
               :  using ::copysignf;
               :  using ::copysignl;
               :
               :  using ::erf;
               :  using ::erff;
               :  using ::erfl;
               :
               :  using ::erfc;
               :  using ::erfcf;
               :  using ::erfcl;
               :
               :  using ::exp2;
               :  using ::exp2f;
               :  using ::exp2l;
               :
               :  using ::expm1;
               :  using ::expm1f;
               :  using ::expm1l;
               :
               :  using ::fdim;
               :  using ::fdimf;
               :  using ::fdiml;
               :
               :  using ::fma;
               :  using ::fmaf;
               :  using ::fmal;
               :
               :  using ::fmax;
               :  using ::fmaxf;
               :  using ::fmaxl;
               :
               :  using ::fmin;
               :  using ::fminf;
               :  using ::fminl;
               :
               :  using ::hypot;
               :  using ::hypotf;
               :  using ::hypotl;
               :
               :  using ::ilogb;
               :  using ::ilogbf;
               :  using ::ilogbl;
               :
               :  using ::lgamma;
               :  using ::lgammaf;
               :  using ::lgammal;
               :
               :  using ::llrint;
               :  using ::llrintf;
               :  using ::llrintl;
               :
               :  using ::llround;
               :  using ::llroundf;
               :  using ::llroundl;
               :
               :  using ::log1p;
               :  using ::log1pf;
               :  using ::log1pl;
               :
               :  using ::log2;
               :  using ::log2f;
               :  using ::log2l;
               :
               :  using ::logb;
               :  using ::logbf;
               :  using ::logbl;
               :
               :  using ::lrint;
               :  using ::lrintf;
               :  using ::lrintl;
               :
               :  using ::lround;
               :  using ::lroundf;
               :  using ::lroundl;
               :
               :  using ::nan;
               :  using ::nanf;
               :  using ::nanl;
               :
               :  using ::nearbyint;
               :  using ::nearbyintf;
               :  using ::nearbyintl;
               :
               :  using ::nextafter;
               :  using ::nextafterf;
               :  using ::nextafterl;
               :
               :  using ::nexttoward;
               :  using ::nexttowardf;
               :  using ::nexttowardl;
               :
               :  using ::remainder;
               :  using ::remainderf;
               :  using ::remainderl;
               :
               :  using ::remquo;
               :  using ::remquof;
               :  using ::remquol;
               :
               :  using ::rint;
               :  using ::rintf;
               :  using ::rintl;
               :
               :  using ::round;
               :  using ::roundf;
               :  using ::roundl;
               :
               :  using ::scalbln;
               :  using ::scalblnf;
               :  using ::scalblnl;
               :
               :  using ::scalbn;
               :  using ::scalbnf;
               :  using ::scalbnl;
               :
               :  using ::tgamma;
               :  using ::tgammaf;
               :  using ::tgammal;
               :
               :  using ::trunc;
               :  using ::truncf;
               :  using ::truncl;
               :
               :  /// Additional overloads.
               :  constexpr float
               :  acosh(float __x)
               :  { return __builtin_acoshf(__x); }
               :
               :  constexpr long double
               :  acosh(long double __x)
               :  { return __builtin_acoshl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    acosh(_Tp __x)
               :    { return __builtin_acosh(__x); }
               :
               :  constexpr float
               :  asinh(float __x)
               :  { return __builtin_asinhf(__x); }
               :
               :  constexpr long double
               :  asinh(long double __x)
               :  { return __builtin_asinhl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    asinh(_Tp __x)
               :    { return __builtin_asinh(__x); }
               :
               :  constexpr float
               :  atanh(float __x)
               :  { return __builtin_atanhf(__x); }
               :
               :  constexpr long double
               :  atanh(long double __x)
               :  { return __builtin_atanhl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    atanh(_Tp __x)
               :    { return __builtin_atanh(__x); }
               :
               :  constexpr float
               :  cbrt(float __x)
               :  { return __builtin_cbrtf(__x); }
               :
               :  constexpr long double
               :  cbrt(long double __x)
               :  { return __builtin_cbrtl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    cbrt(_Tp __x)
               :    { return __builtin_cbrt(__x); }
               :
               :  constexpr float
               :  copysign(float __x, float __y)
               :  { return __builtin_copysignf(__x, __y); }
               :
               :  constexpr long double
               :  copysign(long double __x, long double __y)
               :  { return __builtin_copysignl(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    copysign(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return copysign(__type(__x), __type(__y));
               :    }
               :
               :  constexpr float
               :  erf(float __x)
               :  { return __builtin_erff(__x); }
               :
               :  constexpr long double
               :  erf(long double __x)
               :  { return __builtin_erfl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    erf(_Tp __x)
               :    { return __builtin_erf(__x); }
               :
               :  constexpr float
               :  erfc(float __x)
               :  { return __builtin_erfcf(__x); }
               :
               :  constexpr long double
               :  erfc(long double __x)
               :  { return __builtin_erfcl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    erfc(_Tp __x)
               :    { return __builtin_erfc(__x); }
               :
               :  constexpr float
               :  exp2(float __x)
               :  { return __builtin_exp2f(__x); }
               :
               :  constexpr long double
               :  exp2(long double __x)
               :  { return __builtin_exp2l(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    exp2(_Tp __x)
               :    { return __builtin_exp2(__x); }
               :
               :  constexpr float
               :  expm1(float __x)
               :  { return __builtin_expm1f(__x); }
               :
               :  constexpr long double
               :  expm1(long double __x)
               :  { return __builtin_expm1l(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    expm1(_Tp __x)
               :    { return __builtin_expm1(__x); }
               :
               :  constexpr float
               :  fdim(float __x, float __y)
               :  { return __builtin_fdimf(__x, __y); }
               :
               :  constexpr long double
               :  fdim(long double __x, long double __y)
               :  { return __builtin_fdiml(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    fdim(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return fdim(__type(__x), __type(__y));
               :    }
               :
               :  constexpr float
               :  fma(float __x, float __y, float __z)
               :  { return __builtin_fmaf(__x, __y, __z); }
               :
               :  constexpr long double
               :  fma(long double __x, long double __y, long double __z)
               :  { return __builtin_fmal(__x, __y, __z); }
               :
               :  template<typename _Tp, typename _Up, typename _Vp>
               :    constexpr typename __gnu_cxx::__promote_3<_Tp, _Up, _Vp>::__type
               :    fma(_Tp __x, _Up __y, _Vp __z)
               :    {
               :      typedef typename __gnu_cxx::__promote_3<_Tp, _Up, _Vp>::__type __type;
               :      return fma(__type(__x), __type(__y), __type(__z));
               :    }
               :
               :  constexpr float
               :  fmax(float __x, float __y)
               :  { return __builtin_fmaxf(__x, __y); }
               :
               :  constexpr long double
               :  fmax(long double __x, long double __y)
               :  { return __builtin_fmaxl(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    fmax(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return fmax(__type(__x), __type(__y));
               :    }
               :
               :  constexpr float
               :  fmin(float __x, float __y)
               :  { return __builtin_fminf(__x, __y); }
               :
               :  constexpr long double
               :  fmin(long double __x, long double __y)
               :  { return __builtin_fminl(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    fmin(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return fmin(__type(__x), __type(__y));
               :    }
               :
               :  constexpr float
               :  hypot(float __x, float __y)
               :  { return __builtin_hypotf(__x, __y); }
               :
               :  constexpr long double
               :  hypot(long double __x, long double __y)
               :  { return __builtin_hypotl(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    hypot(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return hypot(__type(__x), __type(__y));
               :    }
               :
               :  constexpr int
               :  ilogb(float __x)
               :  { return __builtin_ilogbf(__x); }
               :
               :  constexpr int
               :  ilogb(long double __x)
               :  { return __builtin_ilogbl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr
               :    typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                    int>::__type
               :    ilogb(_Tp __x)
               :    { return __builtin_ilogb(__x); }
               :
               :  constexpr float
               :  lgamma(float __x)
               :  { return __builtin_lgammaf(__x); }
               :
               :  constexpr long double
               :  lgamma(long double __x)
               :  { return __builtin_lgammal(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    lgamma(_Tp __x)
               :    { return __builtin_lgamma(__x); }
               :
               :  constexpr long long
               :  llrint(float __x)
               :  { return __builtin_llrintf(__x); }
               :
               :  constexpr long long
               :  llrint(long double __x)
               :  { return __builtin_llrintl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              long long>::__type
               :    llrint(_Tp __x)
               :    { return __builtin_llrint(__x); }
               :
               :  constexpr long long
               :  llround(float __x)
               :  { return __builtin_llroundf(__x); }
               :
               :  constexpr long long
               :  llround(long double __x)
               :  { return __builtin_llroundl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              long long>::__type
               :    llround(_Tp __x)
               :    { return __builtin_llround(__x); }
               :
               :  constexpr float
               :  log1p(float __x)
               :  { return __builtin_log1pf(__x); }
               :
               :  constexpr long double
               :  log1p(long double __x)
               :  { return __builtin_log1pl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    log1p(_Tp __x)
               :    { return __builtin_log1p(__x); }
               :
               :  // DR 568.
               :  constexpr float
               :  log2(float __x)
               :  { return __builtin_log2f(__x); }
               :
               :  constexpr long double
               :  log2(long double __x)
               :  { return __builtin_log2l(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    log2(_Tp __x)
               :    { return __builtin_log2(__x); }
               :
               :  constexpr float
               :  logb(float __x)
               :  { return __builtin_logbf(__x); }
               :
               :  constexpr long double
               :  logb(long double __x)
               :  { return __builtin_logbl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    logb(_Tp __x)
               :    { return __builtin_logb(__x); }
               :
               :  constexpr long
               :  lrint(float __x)
               :  { return __builtin_lrintf(__x); }
               :
               :  constexpr long
               :  lrint(long double __x)
               :  { return __builtin_lrintl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              long>::__type
               :    lrint(_Tp __x)
               :    { return __builtin_lrint(__x); }
               :
               :  constexpr long
               :  lround(float __x)
               :  { return __builtin_lroundf(__x); }
               :
               :  constexpr long
               :  lround(long double __x)
               :  { return __builtin_lroundl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              long>::__type
               :    lround(_Tp __x)
               :    { return __builtin_lround(__x); }
               :
               :  constexpr float
               :  nearbyint(float __x)
               :  { return __builtin_nearbyintf(__x); }
               :
               :  constexpr long double
               :  nearbyint(long double __x)
               :  { return __builtin_nearbyintl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    nearbyint(_Tp __x)
               :    { return __builtin_nearbyint(__x); }
               :
               :  constexpr float
               :  nextafter(float __x, float __y)
               :  { return __builtin_nextafterf(__x, __y); }
               :
               :  constexpr long double
               :  nextafter(long double __x, long double __y)
               :  { return __builtin_nextafterl(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    nextafter(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return nextafter(__type(__x), __type(__y));
               :    }
               :
               :  constexpr float
               :  nexttoward(float __x, long double __y)
               :  { return __builtin_nexttowardf(__x, __y); }
               :
               :  constexpr long double
               :  nexttoward(long double __x, long double __y)
               :  { return __builtin_nexttowardl(__x, __y); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    nexttoward(_Tp __x, long double __y)
               :    { return __builtin_nexttoward(__x, __y); }
               :
               :  constexpr float
               :  remainder(float __x, float __y)
               :  { return __builtin_remainderf(__x, __y); }
               :
               :  constexpr long double
               :  remainder(long double __x, long double __y)
               :  { return __builtin_remainderl(__x, __y); }
               :
               :  template<typename _Tp, typename _Up>
               :    constexpr typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    remainder(_Tp __x, _Up __y)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return remainder(__type(__x), __type(__y));
               :    }
               :
               :  inline float
               :  remquo(float __x, float __y, int* __pquo)
               :  { return __builtin_remquof(__x, __y, __pquo); }
               :
               :  inline long double
               :  remquo(long double __x, long double __y, int* __pquo)
               :  { return __builtin_remquol(__x, __y, __pquo); }
               :
               :  template<typename _Tp, typename _Up>
               :    inline typename __gnu_cxx::__promote_2<_Tp, _Up>::__type
               :    remquo(_Tp __x, _Up __y, int* __pquo)
               :    {
               :      typedef typename __gnu_cxx::__promote_2<_Tp, _Up>::__type __type;
               :      return remquo(__type(__x), __type(__y), __pquo);
               :    }
               :
               :  constexpr float
               :  rint(float __x)
               :  { return __builtin_rintf(__x); }
               :
               :  constexpr long double
               :  rint(long double __x)
               :  { return __builtin_rintl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    rint(_Tp __x)
               :    { return __builtin_rint(__x); }
               :
               :  constexpr float
               :  round(float __x)
               :  { return __builtin_roundf(__x); }
               :
               :  constexpr long double
               :  round(long double __x)
               :  { return __builtin_roundl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    round(_Tp __x)
               :    { return __builtin_round(__x); }
               :
               :  constexpr float
               :  scalbln(float __x, long __ex)
               :  { return __builtin_scalblnf(__x, __ex); }
               :
               :  constexpr long double
               :  scalbln(long double __x, long __ex)
               :  { return __builtin_scalblnl(__x, __ex); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    scalbln(_Tp __x, long __ex)
               :    { return __builtin_scalbln(__x, __ex); }
               : 
               :  constexpr float
               :  scalbn(float __x, int __ex)
               :  { return __builtin_scalbnf(__x, __ex); }
               :
               :  constexpr long double
               :  scalbn(long double __x, int __ex)
               :  { return __builtin_scalbnl(__x, __ex); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    scalbn(_Tp __x, int __ex)
               :    { return __builtin_scalbn(__x, __ex); }
               :
               :  constexpr float
               :  tgamma(float __x)
               :  { return __builtin_tgammaf(__x); }
               :
               :  constexpr long double
               :  tgamma(long double __x)
               :  { return __builtin_tgammal(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    tgamma(_Tp __x)
               :    { return __builtin_tgamma(__x); }
               : 
               :  constexpr float
               :  trunc(float __x)
               :  { return __builtin_truncf(__x); }
               :
               :  constexpr long double
               :  trunc(long double __x)
               :  { return __builtin_truncl(__x); }
               :
               :  template<typename _Tp>
               :    constexpr typename __gnu_cxx::__enable_if<__is_integer<_Tp>::__value, 
               :                                              double>::__type
               :    trunc(_Tp __x)
               :    { return __builtin_trunc(__x); }
               :
               :_GLIBCXX_END_NAMESPACE_VERSION
               :} // namespace
               :
               :#endif // _GLIBCXX_USE_C99_MATH_TR1
               :
               :#endif // C++11
               :
               :#endif
/* 
 * Total samples for file : "/usr/lib/gcc/x86_64-pc-linux-gnu/4.9.3/include/g++-v4/bits/stl_vector.h"
 * 
 *     14  0.0050
 */


               :// Vector implementation -*- C++ -*-
               :
               :// Copyright (C) 2001-2014 Free Software Foundation, Inc.
               ://
               :// This file is part of the GNU ISO C++ Library.  This library is free
               :// software; you can redistribute it and/or modify it under the
               :// terms of the GNU General Public License as published by the
               :// Free Software Foundation; either version 3, or (at your option)
               :// any later version.
               :
               :// This library is distributed in the hope that it will be useful,
               :// but WITHOUT ANY WARRANTY; without even the implied warranty of
               :// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
               :// GNU General Public License for more details.
               :
               :// Under Section 7 of GPL version 3, you are granted additional
               :// permissions described in the GCC Runtime Library Exception, version
               :// 3.1, as published by the Free Software Foundation.
               :
               :// You should have received a copy of the GNU General Public License and
               :// a copy of the GCC Runtime Library Exception along with this program;
               :// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
               :// <http://www.gnu.org/licenses/>.
               :
               :/*
               : *
               : * Copyright (c) 1994
               : * Hewlett-Packard Company
               : *
               : * Permission to use, copy, modify, distribute and sell this software
               : * and its documentation for any purpose is hereby granted without fee,
               : * provided that the above copyright notice appear in all copies and
               : * that both that copyright notice and this permission notice appear
               : * in supporting documentation.  Hewlett-Packard Company makes no
               : * representations about the suitability of this software for any
               : * purpose.  It is provided "as is" without express or implied warranty.
               : *
               : *
               : * Copyright (c) 1996
               : * Silicon Graphics Computer Systems, Inc.
               : *
               : * Permission to use, copy, modify, distribute and sell this software
               : * and its documentation for any purpose is hereby granted without fee,
               : * provided that the above copyright notice appear in all copies and
               : * that both that copyright notice and this permission notice appear
               : * in supporting documentation.  Silicon Graphics makes no
               : * representations about the suitability of this  software for any
               : * purpose.  It is provided "as is" without express or implied warranty.
               : */
               :
               :/** @file bits/stl_vector.h
               : *  This is an internal header file, included by other library headers.
               : *  Do not attempt to use it directly. @headername{vector}
               : */
               :
               :#ifndef _STL_VECTOR_H
               :#define _STL_VECTOR_H 1
               :
               :#include <bits/stl_iterator_base_funcs.h>
               :#include <bits/functexcept.h>
               :#include <bits/concept_check.h>
               :#if __cplusplus >= 201103L
               :#include <initializer_list>
               :#endif
               :
               :namespace std _GLIBCXX_VISIBILITY(default)
               :{
               :_GLIBCXX_BEGIN_NAMESPACE_CONTAINER
               :
               :  /// See bits/stl_deque.h's _Deque_base for an explanation.
               :  template<typename _Tp, typename _Alloc>
               :    struct _Vector_base
               :    {
               :      typedef typename __gnu_cxx::__alloc_traits<_Alloc>::template
               :        rebind<_Tp>::other _Tp_alloc_type;
               :      typedef typename __gnu_cxx::__alloc_traits<_Tp_alloc_type>::pointer
               :       	pointer;
               :
               :      struct _Vector_impl 
               :      : public _Tp_alloc_type
               :      {
               :	pointer _M_start;
               :	pointer _M_finish;
               :	pointer _M_end_of_storage;
               :
               :	_Vector_impl()
               :	: _Tp_alloc_type(), _M_start(0), _M_finish(0), _M_end_of_storage(0)
               :	{ }
               :
               :	_Vector_impl(_Tp_alloc_type const& __a) _GLIBCXX_NOEXCEPT
               :	: _Tp_alloc_type(__a), _M_start(0), _M_finish(0), _M_end_of_storage(0)
               :	{ }
               :
               :#if __cplusplus >= 201103L
               :	_Vector_impl(_Tp_alloc_type&& __a) noexcept
               :	: _Tp_alloc_type(std::move(__a)),
               :	  _M_start(0), _M_finish(0), _M_end_of_storage(0)
               :	{ }
               :#endif
               :
               :	void _M_swap_data(_Vector_impl& __x) _GLIBCXX_NOEXCEPT
               :	{
               :	  std::swap(_M_start, __x._M_start);
               :	  std::swap(_M_finish, __x._M_finish);
               :	  std::swap(_M_end_of_storage, __x._M_end_of_storage);
               :	}
               :      };
               :      
               :    public:
               :      typedef _Alloc allocator_type;
               :
               :      _Tp_alloc_type&
               :      _M_get_Tp_allocator() _GLIBCXX_NOEXCEPT
               :      { return *static_cast<_Tp_alloc_type*>(&this->_M_impl); }
               :
               :      const _Tp_alloc_type&
               :      _M_get_Tp_allocator() const _GLIBCXX_NOEXCEPT
               :      { return *static_cast<const _Tp_alloc_type*>(&this->_M_impl); }
               :
               :      allocator_type
               :      get_allocator() const _GLIBCXX_NOEXCEPT
               :      { return allocator_type(_M_get_Tp_allocator()); }
               :
               :      _Vector_base()
               :      : _M_impl() { }
               :
               :      _Vector_base(const allocator_type& __a) _GLIBCXX_NOEXCEPT
               :      : _M_impl(__a) { }
               :
               :      _Vector_base(size_t __n)
               :      : _M_impl()
               :      { _M_create_storage(__n); }
               :
               :      _Vector_base(size_t __n, const allocator_type& __a)
               :      : _M_impl(__a)
               :      { _M_create_storage(__n); }
               :
               :#if __cplusplus >= 201103L
               :      _Vector_base(_Tp_alloc_type&& __a) noexcept
               :      : _M_impl(std::move(__a)) { }
               :
               :      _Vector_base(_Vector_base&& __x) noexcept
               :      : _M_impl(std::move(__x._M_get_Tp_allocator()))
               :      { this->_M_impl._M_swap_data(__x._M_impl); }
               :
               :      _Vector_base(_Vector_base&& __x, const allocator_type& __a)
               :      : _M_impl(__a)
               :      {
               :	if (__x.get_allocator() == __a)
               :	  this->_M_impl._M_swap_data(__x._M_impl);
               :	else
               :	  {
               :	    size_t __n = __x._M_impl._M_finish - __x._M_impl._M_start;
               :	    _M_create_storage(__n);
               :	  }
               :      }
               :#endif
               :
               :      ~_Vector_base() _GLIBCXX_NOEXCEPT
               :      { _M_deallocate(this->_M_impl._M_start, this->_M_impl._M_end_of_storage
               :		      - this->_M_impl._M_start); }
               :
               :    public:
               :      _Vector_impl _M_impl;
               :
               :      pointer
               :      _M_allocate(size_t __n)
               :      {
               :	typedef __gnu_cxx::__alloc_traits<_Tp_alloc_type> _Tr;
               :	return __n != 0 ? _Tr::allocate(_M_impl, __n) : 0;
               :      }
               :
               :      void
               :      _M_deallocate(pointer __p, size_t __n)
               :      {
               :	typedef __gnu_cxx::__alloc_traits<_Tp_alloc_type> _Tr;
               :	if (__p)
               :	  _Tr::deallocate(_M_impl, __p, __n);
               :      }
               :
               :    private:
               :      void
               :      _M_create_storage(size_t __n)
               :      {
               :	this->_M_impl._M_start = this->_M_allocate(__n);
               :	this->_M_impl._M_finish = this->_M_impl._M_start;
               :	this->_M_impl._M_end_of_storage = this->_M_impl._M_start + __n;
               :      }
               :    };
               :
               :
               :  /**
               :   *  @brief A standard container which offers fixed time access to
               :   *  individual elements in any order.
               :   *
               :   *  @ingroup sequences
               :   *
               :   *  @tparam _Tp  Type of element.
               :   *  @tparam _Alloc  Allocator type, defaults to allocator<_Tp>.
               :   *
               :   *  Meets the requirements of a <a href="tables.html#65">container</a>, a
               :   *  <a href="tables.html#66">reversible container</a>, and a
               :   *  <a href="tables.html#67">sequence</a>, including the
               :   *  <a href="tables.html#68">optional sequence requirements</a> with the
               :   *  %exception of @c push_front and @c pop_front.
               :   *
               :   *  In some terminology a %vector can be described as a dynamic
               :   *  C-style array, it offers fast and efficient access to individual
               :   *  elements in any order and saves the user from worrying about
               :   *  memory and size allocation.  Subscripting ( @c [] ) access is
               :   *  also provided as with C-style arrays.
               :  */
               :  template<typename _Tp, typename _Alloc = std::allocator<_Tp> >
               :    class vector : protected _Vector_base<_Tp, _Alloc>
               :    {
               :      // Concept requirements.
               :      typedef typename _Alloc::value_type                _Alloc_value_type;
               :      __glibcxx_class_requires(_Tp, _SGIAssignableConcept)
               :      __glibcxx_class_requires2(_Tp, _Alloc_value_type, _SameTypeConcept)
               :      
               :      typedef _Vector_base<_Tp, _Alloc>			 _Base;
               :      typedef typename _Base::_Tp_alloc_type		 _Tp_alloc_type;
               :      typedef __gnu_cxx::__alloc_traits<_Tp_alloc_type>  _Alloc_traits;
               :
               :    public:
               :      typedef _Tp					 value_type;
               :      typedef typename _Base::pointer                    pointer;
               :      typedef typename _Alloc_traits::const_pointer      const_pointer;
               :      typedef typename _Alloc_traits::reference          reference;
               :      typedef typename _Alloc_traits::const_reference    const_reference;
               :      typedef __gnu_cxx::__normal_iterator<pointer, vector> iterator;
               :      typedef __gnu_cxx::__normal_iterator<const_pointer, vector>
               :      const_iterator;
               :      typedef std::reverse_iterator<const_iterator>  const_reverse_iterator;
               :      typedef std::reverse_iterator<iterator>		 reverse_iterator;
               :      typedef size_t					 size_type;
               :      typedef ptrdiff_t					 difference_type;
               :      typedef _Alloc                        		 allocator_type;
               :
               :    protected:
               :      using _Base::_M_allocate;
               :      using _Base::_M_deallocate;
               :      using _Base::_M_impl;
               :      using _Base::_M_get_Tp_allocator;
               :
               :    public:
               :      // [23.2.4.1] construct/copy/destroy
               :      // (assign() and get_allocator() are also listed in this section)
               :
               :      /**
               :       *  @brief  Creates a %vector with no elements.
               :       */
               :      vector()
               :#if __cplusplus >= 201103L
               :      noexcept(is_nothrow_default_constructible<_Alloc>::value)
               :#endif
               :      : _Base() { }
               :
               :      /**
               :       *  @brief  Creates a %vector with no elements.
               :       *  @param  __a  An allocator object.
               :       */
               :      explicit
               :      vector(const allocator_type& __a) _GLIBCXX_NOEXCEPT
               :      : _Base(__a) { }
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  Creates a %vector with default constructed elements.
               :       *  @param  __n  The number of elements to initially create.
               :       *  @param  __a  An allocator.
               :       *
               :       *  This constructor fills the %vector with @a __n default
               :       *  constructed elements.
               :       */
               :      explicit
               :      vector(size_type __n, const allocator_type& __a = allocator_type())
               :      : _Base(__n, __a)
               :      { _M_default_initialize(__n); }
               :
               :      /**
               :       *  @brief  Creates a %vector with copies of an exemplar element.
               :       *  @param  __n  The number of elements to initially create.
               :       *  @param  __value  An element to copy.
               :       *  @param  __a  An allocator.
               :       *
               :       *  This constructor fills the %vector with @a __n copies of @a __value.
               :       */
               :      vector(size_type __n, const value_type& __value,
               :	     const allocator_type& __a = allocator_type())
               :      : _Base(__n, __a)
               :      { _M_fill_initialize(__n, __value); }
               :#else
               :      /**
               :       *  @brief  Creates a %vector with copies of an exemplar element.
               :       *  @param  __n  The number of elements to initially create.
               :       *  @param  __value  An element to copy.
               :       *  @param  __a  An allocator.
               :       *
               :       *  This constructor fills the %vector with @a __n copies of @a __value.
               :       */
               :      explicit
               :      vector(size_type __n, const value_type& __value = value_type(),
               :	     const allocator_type& __a = allocator_type())
               :      : _Base(__n, __a)
               :      { _M_fill_initialize(__n, __value); }
               :#endif
               :
               :      /**
               :       *  @brief  %Vector copy constructor.
               :       *  @param  __x  A %vector of identical element and allocator types.
               :       *
               :       *  The newly-created %vector uses a copy of the allocation
               :       *  object used by @a __x.  All the elements of @a __x are copied,
               :       *  but any extra memory in
               :       *  @a __x (for fast expansion) will not be copied.
               :       */
               :      vector(const vector& __x)
               :      : _Base(__x.size(),
               :        _Alloc_traits::_S_select_on_copy(__x._M_get_Tp_allocator()))
               :      { this->_M_impl._M_finish =
               :	  std::__uninitialized_copy_a(__x.begin(), __x.end(),
               :				      this->_M_impl._M_start,
               :				      _M_get_Tp_allocator());
               :      }
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  %Vector move constructor.
               :       *  @param  __x  A %vector of identical element and allocator types.
               :       *
               :       *  The newly-created %vector contains the exact contents of @a __x.
               :       *  The contents of @a __x are a valid, but unspecified %vector.
               :       */
               :      vector(vector&& __x) noexcept
               :      : _Base(std::move(__x)) { }
               :
               :      /// Copy constructor with alternative allocator
               :      vector(const vector& __x, const allocator_type& __a)
               :      : _Base(__x.size(), __a)
               :      { this->_M_impl._M_finish =
               :	  std::__uninitialized_copy_a(__x.begin(), __x.end(),
               :				      this->_M_impl._M_start,
               :				      _M_get_Tp_allocator());
               :      }
               :
               :      /// Move constructor with alternative allocator
               :      vector(vector&& __rv, const allocator_type& __m)
               :      noexcept(_Alloc_traits::_S_always_equal())
               :      : _Base(std::move(__rv), __m)
               :      {
               :	if (__rv.get_allocator() != __m)
               :	  {
               :	    this->_M_impl._M_finish =
               :	      std::__uninitialized_move_a(__rv.begin(), __rv.end(),
               :					  this->_M_impl._M_start,
               :					  _M_get_Tp_allocator());
               :	    __rv.clear();
               :	  }
               :      }
               :
               :      /**
               :       *  @brief  Builds a %vector from an initializer list.
               :       *  @param  __l  An initializer_list.
               :       *  @param  __a  An allocator.
               :       *
               :       *  Create a %vector consisting of copies of the elements in the
               :       *  initializer_list @a __l.
               :       *
               :       *  This will call the element type's copy constructor N times
               :       *  (where N is @a __l.size()) and do no memory reallocation.
               :       */
               :      vector(initializer_list<value_type> __l,
               :	     const allocator_type& __a = allocator_type())
               :      : _Base(__a)
               :      {
               :	_M_range_initialize(__l.begin(), __l.end(),
               :			    random_access_iterator_tag());
               :      }
               :#endif
               :
               :      /**
               :       *  @brief  Builds a %vector from a range.
               :       *  @param  __first  An input iterator.
               :       *  @param  __last  An input iterator.
               :       *  @param  __a  An allocator.
               :       *
               :       *  Create a %vector consisting of copies of the elements from
               :       *  [first,last).
               :       *
               :       *  If the iterators are forward, bidirectional, or
               :       *  random-access, then this will call the elements' copy
               :       *  constructor N times (where N is distance(first,last)) and do
               :       *  no memory reallocation.  But if only input iterators are
               :       *  used, then this will do at most 2N calls to the copy
               :       *  constructor, and logN memory reallocations.
               :       */
               :#if __cplusplus >= 201103L
               :      template<typename _InputIterator,
               :	       typename = std::_RequireInputIter<_InputIterator>>
               :        vector(_InputIterator __first, _InputIterator __last,
               :	       const allocator_type& __a = allocator_type())
               :	: _Base(__a)
               :        { _M_initialize_dispatch(__first, __last, __false_type()); }
               :#else
               :      template<typename _InputIterator>
               :        vector(_InputIterator __first, _InputIterator __last,
               :	       const allocator_type& __a = allocator_type())
               :	: _Base(__a)
               :        {
               :	  // Check whether it's an integral type.  If so, it's not an iterator.
               :	  typedef typename std::__is_integer<_InputIterator>::__type _Integral;
               :	  _M_initialize_dispatch(__first, __last, _Integral());
               :	}
               :#endif
               :
               :      /**
               :       *  The dtor only erases the elements, and note that if the
               :       *  elements themselves are pointers, the pointed-to memory is
               :       *  not touched in any way.  Managing the pointer is the user's
               :       *  responsibility.
               :       */
               :      ~vector() _GLIBCXX_NOEXCEPT
               :      { std::_Destroy(this->_M_impl._M_start, this->_M_impl._M_finish,
               :		      _M_get_Tp_allocator()); }
               :
               :      /**
               :       *  @brief  %Vector assignment operator.
               :       *  @param  __x  A %vector of identical element and allocator types.
               :       *
               :       *  All the elements of @a __x are copied, but any extra memory in
               :       *  @a __x (for fast expansion) will not be copied.  Unlike the
               :       *  copy constructor, the allocator object is not copied.
               :       */
               :      vector&
               :      operator=(const vector& __x);
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  %Vector move assignment operator.
               :       *  @param  __x  A %vector of identical element and allocator types.
               :       *
               :       *  The contents of @a __x are moved into this %vector (without copying,
               :       *  if the allocators permit it).
               :       *  @a __x is a valid, but unspecified %vector.
               :       */
               :      vector&
               :      operator=(vector&& __x) noexcept(_Alloc_traits::_S_nothrow_move())
               :      {
               :        constexpr bool __move_storage =
               :          _Alloc_traits::_S_propagate_on_move_assign()
               :          || _Alloc_traits::_S_always_equal();
               :        _M_move_assign(std::move(__x),
               :                       integral_constant<bool, __move_storage>());
               :	return *this;
               :      }
               :
               :      /**
               :       *  @brief  %Vector list assignment operator.
               :       *  @param  __l  An initializer_list.
               :       *
               :       *  This function fills a %vector with copies of the elements in the
               :       *  initializer list @a __l.
               :       *
               :       *  Note that the assignment completely changes the %vector and
               :       *  that the resulting %vector's size is the same as the number
               :       *  of elements assigned.  Old data may be lost.
               :       */
               :      vector&
               :      operator=(initializer_list<value_type> __l)
               :      {
               :	this->assign(__l.begin(), __l.end());
               :	return *this;
               :      }
               :#endif
               :
               :      /**
               :       *  @brief  Assigns a given value to a %vector.
               :       *  @param  __n  Number of elements to be assigned.
               :       *  @param  __val  Value to be assigned.
               :       *
               :       *  This function fills a %vector with @a __n copies of the given
               :       *  value.  Note that the assignment completely changes the
               :       *  %vector and that the resulting %vector's size is the same as
               :       *  the number of elements assigned.  Old data may be lost.
               :       */
               :      void
               :      assign(size_type __n, const value_type& __val)
               :      { _M_fill_assign(__n, __val); }
               :
               :      /**
               :       *  @brief  Assigns a range to a %vector.
               :       *  @param  __first  An input iterator.
               :       *  @param  __last   An input iterator.
               :       *
               :       *  This function fills a %vector with copies of the elements in the
               :       *  range [__first,__last).
               :       *
               :       *  Note that the assignment completely changes the %vector and
               :       *  that the resulting %vector's size is the same as the number
               :       *  of elements assigned.  Old data may be lost.
               :       */
               :#if __cplusplus >= 201103L
               :      template<typename _InputIterator,
               :	       typename = std::_RequireInputIter<_InputIterator>>
               :        void
               :        assign(_InputIterator __first, _InputIterator __last)
               :        { _M_assign_dispatch(__first, __last, __false_type()); }
               :#else
               :      template<typename _InputIterator>
               :        void
               :        assign(_InputIterator __first, _InputIterator __last)
               :        {
               :	  // Check whether it's an integral type.  If so, it's not an iterator.
               :	  typedef typename std::__is_integer<_InputIterator>::__type _Integral;
               :	  _M_assign_dispatch(__first, __last, _Integral());
               :	}
               :#endif
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  Assigns an initializer list to a %vector.
               :       *  @param  __l  An initializer_list.
               :       *
               :       *  This function fills a %vector with copies of the elements in the
               :       *  initializer list @a __l.
               :       *
               :       *  Note that the assignment completely changes the %vector and
               :       *  that the resulting %vector's size is the same as the number
               :       *  of elements assigned.  Old data may be lost.
               :       */
               :      void
               :      assign(initializer_list<value_type> __l)
               :      { this->assign(__l.begin(), __l.end()); }
               :#endif
               :
               :      /// Get a copy of the memory allocation object.
               :      using _Base::get_allocator;
               :
               :      // iterators
               :      /**
               :       *  Returns a read/write iterator that points to the first
               :       *  element in the %vector.  Iteration is done in ordinary
               :       *  element order.
               :       */
               :      iterator
               :      begin() _GLIBCXX_NOEXCEPT
               :      { return iterator(this->_M_impl._M_start); }
               :
               :      /**
               :       *  Returns a read-only (constant) iterator that points to the
               :       *  first element in the %vector.  Iteration is done in ordinary
               :       *  element order.
               :       */
               :      const_iterator
               :      begin() const _GLIBCXX_NOEXCEPT
               :      { return const_iterator(this->_M_impl._M_start); }
               :
               :      /**
               :       *  Returns a read/write iterator that points one past the last
               :       *  element in the %vector.  Iteration is done in ordinary
               :       *  element order.
               :       */
               :      iterator
               :      end() _GLIBCXX_NOEXCEPT
               :      { return iterator(this->_M_impl._M_finish); }
               :
               :      /**
               :       *  Returns a read-only (constant) iterator that points one past
               :       *  the last element in the %vector.  Iteration is done in
               :       *  ordinary element order.
               :       */
               :      const_iterator
               :      end() const _GLIBCXX_NOEXCEPT
               :      { return const_iterator(this->_M_impl._M_finish); }
               :
               :      /**
               :       *  Returns a read/write reverse iterator that points to the
               :       *  last element in the %vector.  Iteration is done in reverse
               :       *  element order.
               :       */
               :      reverse_iterator
               :      rbegin() _GLIBCXX_NOEXCEPT
               :      { return reverse_iterator(end()); }
               :
               :      /**
               :       *  Returns a read-only (constant) reverse iterator that points
               :       *  to the last element in the %vector.  Iteration is done in
               :       *  reverse element order.
               :       */
               :      const_reverse_iterator
               :      rbegin() const _GLIBCXX_NOEXCEPT
               :      { return const_reverse_iterator(end()); }
               :
               :      /**
               :       *  Returns a read/write reverse iterator that points to one
               :       *  before the first element in the %vector.  Iteration is done
               :       *  in reverse element order.
               :       */
               :      reverse_iterator
               :      rend() _GLIBCXX_NOEXCEPT
               :      { return reverse_iterator(begin()); }
               :
               :      /**
               :       *  Returns a read-only (constant) reverse iterator that points
               :       *  to one before the first element in the %vector.  Iteration
               :       *  is done in reverse element order.
               :       */
               :      const_reverse_iterator
               :      rend() const _GLIBCXX_NOEXCEPT
               :      { return const_reverse_iterator(begin()); }
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  Returns a read-only (constant) iterator that points to the
               :       *  first element in the %vector.  Iteration is done in ordinary
               :       *  element order.
               :       */
               :      const_iterator
               :      cbegin() const noexcept
               :      { return const_iterator(this->_M_impl._M_start); }
               :
               :      /**
               :       *  Returns a read-only (constant) iterator that points one past
               :       *  the last element in the %vector.  Iteration is done in
               :       *  ordinary element order.
               :       */
               :      const_iterator
               :      cend() const noexcept
               :      { return const_iterator(this->_M_impl._M_finish); }
               :
               :      /**
               :       *  Returns a read-only (constant) reverse iterator that points
               :       *  to the last element in the %vector.  Iteration is done in
               :       *  reverse element order.
               :       */
               :      const_reverse_iterator
               :      crbegin() const noexcept
               :      { return const_reverse_iterator(end()); }
               :
               :      /**
               :       *  Returns a read-only (constant) reverse iterator that points
               :       *  to one before the first element in the %vector.  Iteration
               :       *  is done in reverse element order.
               :       */
               :      const_reverse_iterator
               :      crend() const noexcept
               :      { return const_reverse_iterator(begin()); }
               :#endif
               :
               :      // [23.2.4.2] capacity
               :      /**  Returns the number of elements in the %vector.  */
               :      size_type
               :      size() const _GLIBCXX_NOEXCEPT
               :      { return size_type(this->_M_impl._M_finish - this->_M_impl._M_start); }
               :
               :      /**  Returns the size() of the largest possible %vector.  */
               :      size_type
               :      max_size() const _GLIBCXX_NOEXCEPT
               :      { return _Alloc_traits::max_size(_M_get_Tp_allocator()); }
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  Resizes the %vector to the specified number of elements.
               :       *  @param  __new_size  Number of elements the %vector should contain.
               :       *
               :       *  This function will %resize the %vector to the specified
               :       *  number of elements.  If the number is smaller than the
               :       *  %vector's current size the %vector is truncated, otherwise
               :       *  default constructed elements are appended.
               :       */
               :      void
               :      resize(size_type __new_size)
               :      {
               :	if (__new_size > size())
               :	  _M_default_append(__new_size - size());
               :	else if (__new_size < size())
               :	  _M_erase_at_end(this->_M_impl._M_start + __new_size);
               :      }
               :
               :      /**
               :       *  @brief  Resizes the %vector to the specified number of elements.
               :       *  @param  __new_size  Number of elements the %vector should contain.
               :       *  @param  __x  Data with which new elements should be populated.
               :       *
               :       *  This function will %resize the %vector to the specified
               :       *  number of elements.  If the number is smaller than the
               :       *  %vector's current size the %vector is truncated, otherwise
               :       *  the %vector is extended and new elements are populated with
               :       *  given data.
               :       */
               :      void
               :      resize(size_type __new_size, const value_type& __x)
               :      {
               :	if (__new_size > size())
               :	  insert(end(), __new_size - size(), __x);
               :	else if (__new_size < size())
               :	  _M_erase_at_end(this->_M_impl._M_start + __new_size);
               :      }
               :#else
               :      /**
               :       *  @brief  Resizes the %vector to the specified number of elements.
               :       *  @param  __new_size  Number of elements the %vector should contain.
               :       *  @param  __x  Data with which new elements should be populated.
               :       *
               :       *  This function will %resize the %vector to the specified
               :       *  number of elements.  If the number is smaller than the
               :       *  %vector's current size the %vector is truncated, otherwise
               :       *  the %vector is extended and new elements are populated with
               :       *  given data.
               :       */
               :      void
               :      resize(size_type __new_size, value_type __x = value_type())
               :      {
               :	if (__new_size > size())
               :	  insert(end(), __new_size - size(), __x);
               :	else if (__new_size < size())
               :	  _M_erase_at_end(this->_M_impl._M_start + __new_size);
               :      }
               :#endif
               :
               :#if __cplusplus >= 201103L
               :      /**  A non-binding request to reduce capacity() to size().  */
               :      void
               :      shrink_to_fit()
               :      { _M_shrink_to_fit(); }
               :#endif
               :
               :      /**
               :       *  Returns the total number of elements that the %vector can
               :       *  hold before needing to allocate more memory.
               :       */
               :      size_type
               :      capacity() const _GLIBCXX_NOEXCEPT
               :      { return size_type(this->_M_impl._M_end_of_storage
               :			 - this->_M_impl._M_start); }
               :
               :      /**
               :       *  Returns true if the %vector is empty.  (Thus begin() would
               :       *  equal end().)
               :       */
               :      bool
               :      empty() const _GLIBCXX_NOEXCEPT
               :      { return begin() == end(); }
               :
               :      /**
               :       *  @brief  Attempt to preallocate enough memory for specified number of
               :       *          elements.
               :       *  @param  __n  Number of elements required.
               :       *  @throw  std::length_error  If @a n exceeds @c max_size().
               :       *
               :       *  This function attempts to reserve enough memory for the
               :       *  %vector to hold the specified number of elements.  If the
               :       *  number requested is more than max_size(), length_error is
               :       *  thrown.
               :       *
               :       *  The advantage of this function is that if optimal code is a
               :       *  necessity and the user can determine the number of elements
               :       *  that will be required, the user can reserve the memory in
               :       *  %advance, and thus prevent a possible reallocation of memory
               :       *  and copying of %vector data.
               :       */
               :      void
               :      reserve(size_type __n);
               :
               :      // element access
               :      /**
               :       *  @brief  Subscript access to the data contained in the %vector.
               :       *  @param __n The index of the element for which data should be
               :       *  accessed.
               :       *  @return  Read/write reference to data.
               :       *
               :       *  This operator allows for easy, array-style, data access.
               :       *  Note that data access with this operator is unchecked and
               :       *  out_of_range lookups are not defined. (For checked lookups
               :       *  see at().)
               :       */
               :      reference
               :      operator[](size_type __n) _GLIBCXX_NOEXCEPT
    14  0.0050 :      { return *(this->_M_impl._M_start + __n); }
               :
               :      /**
               :       *  @brief  Subscript access to the data contained in the %vector.
               :       *  @param __n The index of the element for which data should be
               :       *  accessed.
               :       *  @return  Read-only (constant) reference to data.
               :       *
               :       *  This operator allows for easy, array-style, data access.
               :       *  Note that data access with this operator is unchecked and
               :       *  out_of_range lookups are not defined. (For checked lookups
               :       *  see at().)
               :       */
               :      const_reference
               :      operator[](size_type __n) const _GLIBCXX_NOEXCEPT
               :      { return *(this->_M_impl._M_start + __n); }
               :
               :    protected:
               :      /// Safety check used only from at().
               :      void
               :      _M_range_check(size_type __n) const
               :      {
               :	if (__n >= this->size())
               :	  __throw_out_of_range_fmt(__N("vector::_M_range_check: __n "
               :				       "(which is %zu) >= this->size() "
               :				       "(which is %zu)"),
               :				   __n, this->size());
               :      }
               :
               :    public:
               :      /**
               :       *  @brief  Provides access to the data contained in the %vector.
               :       *  @param __n The index of the element for which data should be
               :       *  accessed.
               :       *  @return  Read/write reference to data.
               :       *  @throw  std::out_of_range  If @a __n is an invalid index.
               :       *
               :       *  This function provides for safer data access.  The parameter
               :       *  is first checked that it is in the range of the vector.  The
               :       *  function throws out_of_range if the check fails.
               :       */
               :      reference
               :      at(size_type __n)
               :      {
               :	_M_range_check(__n);
               :	return (*this)[__n]; 
               :      }
               :
               :      /**
               :       *  @brief  Provides access to the data contained in the %vector.
               :       *  @param __n The index of the element for which data should be
               :       *  accessed.
               :       *  @return  Read-only (constant) reference to data.
               :       *  @throw  std::out_of_range  If @a __n is an invalid index.
               :       *
               :       *  This function provides for safer data access.  The parameter
               :       *  is first checked that it is in the range of the vector.  The
               :       *  function throws out_of_range if the check fails.
               :       */
               :      const_reference
               :      at(size_type __n) const
               :      {
               :	_M_range_check(__n);
               :	return (*this)[__n];
               :      }
               :
               :      /**
               :       *  Returns a read/write reference to the data at the first
               :       *  element of the %vector.
               :       */
               :      reference
               :      front() _GLIBCXX_NOEXCEPT
               :      { return *begin(); }
               :
               :      /**
               :       *  Returns a read-only (constant) reference to the data at the first
               :       *  element of the %vector.
               :       */
               :      const_reference
               :      front() const _GLIBCXX_NOEXCEPT
               :      { return *begin(); }
               :
               :      /**
               :       *  Returns a read/write reference to the data at the last
               :       *  element of the %vector.
               :       */
               :      reference
               :      back() _GLIBCXX_NOEXCEPT
               :      { return *(end() - 1); }
               :      
               :      /**
               :       *  Returns a read-only (constant) reference to the data at the
               :       *  last element of the %vector.
               :       */
               :      const_reference
               :      back() const _GLIBCXX_NOEXCEPT
               :      { return *(end() - 1); }
               :
               :      // _GLIBCXX_RESOLVE_LIB_DEFECTS
               :      // DR 464. Suggestion for new member functions in standard containers.
               :      // data access
               :      /**
               :       *   Returns a pointer such that [data(), data() + size()) is a valid
               :       *   range.  For a non-empty %vector, data() == &front().
               :       */
               :#if __cplusplus >= 201103L
               :      _Tp*
               :#else
               :      pointer
               :#endif
               :      data() _GLIBCXX_NOEXCEPT
               :      { return _M_data_ptr(this->_M_impl._M_start); }
               :
               :#if __cplusplus >= 201103L
               :      const _Tp*
               :#else
               :      const_pointer
               :#endif
               :      data() const _GLIBCXX_NOEXCEPT
               :      { return _M_data_ptr(this->_M_impl._M_start); }
               :
               :      // [23.2.4.3] modifiers
               :      /**
               :       *  @brief  Add data to the end of the %vector.
               :       *  @param  __x  Data to be added.
               :       *
               :       *  This is a typical stack operation.  The function creates an
               :       *  element at the end of the %vector and assigns the given data
               :       *  to it.  Due to the nature of a %vector this operation can be
               :       *  done in constant time if the %vector has preallocated space
               :       *  available.
               :       */
               :      void
               :      push_back(const value_type& __x)
               :      {
               :	if (this->_M_impl._M_finish != this->_M_impl._M_end_of_storage)
               :	  {
               :	    _Alloc_traits::construct(this->_M_impl, this->_M_impl._M_finish,
               :	                             __x);
               :	    ++this->_M_impl._M_finish;
               :	  }
               :	else
               :#if __cplusplus >= 201103L
               :	  _M_emplace_back_aux(__x);
               :#else
               :	  _M_insert_aux(end(), __x);
               :#endif
               :      }
               :
               :#if __cplusplus >= 201103L
               :      void
               :      push_back(value_type&& __x)
               :      { emplace_back(std::move(__x)); }
               :
               :      template<typename... _Args>
               :        void
               :        emplace_back(_Args&&... __args);
               :#endif
               :
               :      /**
               :       *  @brief  Removes last element.
               :       *
               :       *  This is a typical stack operation. It shrinks the %vector by one.
               :       *
               :       *  Note that no data is returned, and if the last element's
               :       *  data is needed, it should be retrieved before pop_back() is
               :       *  called.
               :       */
               :      void
               :      pop_back() _GLIBCXX_NOEXCEPT
               :      {
               :	--this->_M_impl._M_finish;
               :	_Alloc_traits::destroy(this->_M_impl, this->_M_impl._M_finish);
               :      }
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  Inserts an object in %vector before specified iterator.
               :       *  @param  __position  A const_iterator into the %vector.
               :       *  @param  __args  Arguments.
               :       *  @return  An iterator that points to the inserted data.
               :       *
               :       *  This function will insert an object of type T constructed
               :       *  with T(std::forward<Args>(args)...) before the specified location.
               :       *  Note that this kind of operation could be expensive for a %vector
               :       *  and if it is frequently used the user should consider using
               :       *  std::list.
               :       */
               :      template<typename... _Args>
               :        iterator
               :        emplace(const_iterator __position, _Args&&... __args);
               :
               :      /**
               :       *  @brief  Inserts given value into %vector before specified iterator.
               :       *  @param  __position  A const_iterator into the %vector.
               :       *  @param  __x  Data to be inserted.
               :       *  @return  An iterator that points to the inserted data.
               :       *
               :       *  This function will insert a copy of the given value before
               :       *  the specified location.  Note that this kind of operation
               :       *  could be expensive for a %vector and if it is frequently
               :       *  used the user should consider using std::list.
               :       */
               :      iterator
               :      insert(const_iterator __position, const value_type& __x);
               :#else
               :      /**
               :       *  @brief  Inserts given value into %vector before specified iterator.
               :       *  @param  __position  An iterator into the %vector.
               :       *  @param  __x  Data to be inserted.
               :       *  @return  An iterator that points to the inserted data.
               :       *
               :       *  This function will insert a copy of the given value before
               :       *  the specified location.  Note that this kind of operation
               :       *  could be expensive for a %vector and if it is frequently
               :       *  used the user should consider using std::list.
               :       */
               :      iterator
               :      insert(iterator __position, const value_type& __x);
               :#endif
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  Inserts given rvalue into %vector before specified iterator.
               :       *  @param  __position  A const_iterator into the %vector.
               :       *  @param  __x  Data to be inserted.
               :       *  @return  An iterator that points to the inserted data.
               :       *
               :       *  This function will insert a copy of the given rvalue before
               :       *  the specified location.  Note that this kind of operation
               :       *  could be expensive for a %vector and if it is frequently
               :       *  used the user should consider using std::list.
               :       */
               :      iterator
               :      insert(const_iterator __position, value_type&& __x)
               :      { return emplace(__position, std::move(__x)); }
               :
               :      /**
               :       *  @brief  Inserts an initializer_list into the %vector.
               :       *  @param  __position  An iterator into the %vector.
               :       *  @param  __l  An initializer_list.
               :       *
               :       *  This function will insert copies of the data in the 
               :       *  initializer_list @a l into the %vector before the location
               :       *  specified by @a position.
               :       *
               :       *  Note that this kind of operation could be expensive for a
               :       *  %vector and if it is frequently used the user should
               :       *  consider using std::list.
               :       */
               :      iterator
               :      insert(const_iterator __position, initializer_list<value_type> __l)
               :      { return this->insert(__position, __l.begin(), __l.end()); }
               :#endif
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  Inserts a number of copies of given data into the %vector.
               :       *  @param  __position  A const_iterator into the %vector.
               :       *  @param  __n  Number of elements to be inserted.
               :       *  @param  __x  Data to be inserted.
               :       *  @return  An iterator that points to the inserted data.
               :       *
               :       *  This function will insert a specified number of copies of
               :       *  the given data before the location specified by @a position.
               :       *
               :       *  Note that this kind of operation could be expensive for a
               :       *  %vector and if it is frequently used the user should
               :       *  consider using std::list.
               :       */
               :      iterator
               :      insert(const_iterator __position, size_type __n, const value_type& __x)
               :      {
               :	difference_type __offset = __position - cbegin();
               :	_M_fill_insert(begin() + __offset, __n, __x);
               :	return begin() + __offset;
               :      }
               :#else
               :      /**
               :       *  @brief  Inserts a number of copies of given data into the %vector.
               :       *  @param  __position  An iterator into the %vector.
               :       *  @param  __n  Number of elements to be inserted.
               :       *  @param  __x  Data to be inserted.
               :       *
               :       *  This function will insert a specified number of copies of
               :       *  the given data before the location specified by @a position.
               :       *
               :       *  Note that this kind of operation could be expensive for a
               :       *  %vector and if it is frequently used the user should
               :       *  consider using std::list.
               :       */
               :      void
               :      insert(iterator __position, size_type __n, const value_type& __x)
               :      { _M_fill_insert(__position, __n, __x); }
               :#endif
               :
               :#if __cplusplus >= 201103L
               :      /**
               :       *  @brief  Inserts a range into the %vector.
               :       *  @param  __position  A const_iterator into the %vector.
               :       *  @param  __first  An input iterator.
               :       *  @param  __last   An input iterator.
               :       *  @return  An iterator that points to the inserted data.
               :       *
               :       *  This function will insert copies of the data in the range
               :       *  [__first,__last) into the %vector before the location specified
               :       *  by @a pos.
               :       *
               :       *  Note that this kind of operation could be expensive for a
               :       *  %vector and if it is frequently used the user should
               :       *  consider using std::list.
               :       */
               :      template<typename _InputIterator,
               :	       typename = std::_RequireInputIter<_InputIterator>>
               :        iterator
               :        insert(const_iterator __position, _InputIterator __first,
               :	       _InputIterator __last)
               :        {
               :	  difference_type __offset = __position - cbegin();
               :	  _M_insert_dispatch(begin() + __offset,
               :			     __first, __last, __false_type());
               :	  return begin() + __offset;
               :	}
               :#else
               :      /**
               :       *  @brief  Inserts a range into the %vector.
               :       *  @param  __position  An iterator into the %vector.
               :       *  @param  __first  An input iterator.
               :       *  @param  __last   An input iterator.
               :       *
               :       *  This function will insert copies of the data in the range
               :       *  [__first,__last) into the %vector before the location specified
               :       *  by @a pos.
               :       *
               :       *  Note that this kind of operation could be expensive for a
               :       *  %vector and if it is frequently used the user should
               :       *  consider using std::list.
               :       */
               :      template<typename _InputIterator>
               :        void
               :        insert(iterator __position, _InputIterator __first,
               :	       _InputIterator __last)
               :        {
               :	  // Check whether it's an integral type.  If so, it's not an iterator.
               :	  typedef typename std::__is_integer<_InputIterator>::__type _Integral;
               :	  _M_insert_dispatch(__position, __first, __last, _Integral());
               :	}
               :#endif
               :
               :      /**
               :       *  @brief  Remove element at given position.
               :       *  @param  __position  Iterator pointing to element to be erased.
               :       *  @return  An iterator pointing to the next element (or end()).
               :       *
               :       *  This function will erase the element at the given position and thus
               :       *  shorten the %vector by one.
               :       *
               :       *  Note This operation could be expensive and if it is
               :       *  frequently used the user should consider using std::list.
               :       *  The user is also cautioned that this function only erases
               :       *  the element, and that if the element is itself a pointer,
               :       *  the pointed-to memory is not touched in any way.  Managing
               :       *  the pointer is the user's responsibility.
               :       */
               :      iterator
               :#if __cplusplus >= 201103L
               :      erase(const_iterator __position)
               :      { return _M_erase(begin() + (__position - cbegin())); }
               :#else
               :      erase(iterator __position)
               :      { return _M_erase(__position); }
               :#endif
               :
               :      /**
               :       *  @brief  Remove a range of elements.
               :       *  @param  __first  Iterator pointing to the first element to be erased.
               :       *  @param  __last  Iterator pointing to one past the last element to be
               :       *                  erased.
               :       *  @return  An iterator pointing to the element pointed to by @a __last
               :       *           prior to erasing (or end()).
               :       *
               :       *  This function will erase the elements in the range
               :       *  [__first,__last) and shorten the %vector accordingly.
               :       *
               :       *  Note This operation could be expensive and if it is
               :       *  frequently used the user should consider using std::list.
               :       *  The user is also cautioned that this function only erases
               :       *  the elements, and that if the elements themselves are
               :       *  pointers, the pointed-to memory is not touched in any way.
               :       *  Managing the pointer is the user's responsibility.
               :       */
               :      iterator
               :#if __cplusplus >= 201103L
               :      erase(const_iterator __first, const_iterator __last)
               :      {
               :	const auto __beg = begin();
               :	const auto __cbeg = cbegin();
               :	return _M_erase(__beg + (__first - __cbeg), __beg + (__last - __cbeg));
               :      }
               :#else
               :      erase(iterator __first, iterator __last)
               :      { return _M_erase(__first, __last); }
               :#endif
               :
               :      /**
               :       *  @brief  Swaps data with another %vector.
               :       *  @param  __x  A %vector of the same element and allocator types.
               :       *
               :       *  This exchanges the elements between two vectors in constant time.
               :       *  (Three pointers, so it should be quite fast.)
               :       *  Note that the global std::swap() function is specialized such that
               :       *  std::swap(v1,v2) will feed to this function.
               :       */
               :      void
               :      swap(vector& __x)
               :#if __cplusplus >= 201103L
               :      noexcept(_Alloc_traits::_S_nothrow_swap())
               :#endif
               :      {
               :	this->_M_impl._M_swap_data(__x._M_impl);
               :	_Alloc_traits::_S_on_swap(_M_get_Tp_allocator(),
               :	                          __x._M_get_Tp_allocator());
               :      }
               :
               :      /**
               :       *  Erases all the elements.  Note that this function only erases the
               :       *  elements, and that if the elements themselves are pointers, the
               :       *  pointed-to memory is not touched in any way.  Managing the pointer is
               :       *  the user's responsibility.
               :       */
               :      void
               :      clear() _GLIBCXX_NOEXCEPT
               :      { _M_erase_at_end(this->_M_impl._M_start); }
               :
               :    protected:
               :      /**
               :       *  Memory expansion handler.  Uses the member allocation function to
               :       *  obtain @a n bytes of memory, and then copies [first,last) into it.
               :       */
               :      template<typename _ForwardIterator>
               :        pointer
               :        _M_allocate_and_copy(size_type __n,
               :			     _ForwardIterator __first, _ForwardIterator __last)
               :        {
               :	  pointer __result = this->_M_allocate(__n);
               :	  __try
               :	    {
               :	      std::__uninitialized_copy_a(__first, __last, __result,
               :					  _M_get_Tp_allocator());
               :	      return __result;
               :	    }
               :	  __catch(...)
               :	    {
               :	      _M_deallocate(__result, __n);
               :	      __throw_exception_again;
               :	    }
               :	}
               :
               :
               :      // Internal constructor functions follow.
               :
               :      // Called by the range constructor to implement [23.1.1]/9
               :
               :      // _GLIBCXX_RESOLVE_LIB_DEFECTS
               :      // 438. Ambiguity in the "do the right thing" clause
               :      template<typename _Integer>
               :        void
               :        _M_initialize_dispatch(_Integer __n, _Integer __value, __true_type)
               :        {
               :	  this->_M_impl._M_start = _M_allocate(static_cast<size_type>(__n));
               :	  this->_M_impl._M_end_of_storage =
               :	    this->_M_impl._M_start + static_cast<size_type>(__n);
               :	  _M_fill_initialize(static_cast<size_type>(__n), __value);
               :	}
               :
               :      // Called by the range constructor to implement [23.1.1]/9
               :      template<typename _InputIterator>
               :        void
               :        _M_initialize_dispatch(_InputIterator __first, _InputIterator __last,
               :			       __false_type)
               :        {
               :	  typedef typename std::iterator_traits<_InputIterator>::
               :	    iterator_category _IterCategory;
               :	  _M_range_initialize(__first, __last, _IterCategory());
               :	}
               :
               :      // Called by the second initialize_dispatch above
               :      template<typename _InputIterator>
               :        void
               :        _M_range_initialize(_InputIterator __first,
               :			    _InputIterator __last, std::input_iterator_tag)
               :        {
               :	  for (; __first != __last; ++__first)
               :#if __cplusplus >= 201103L
               :	    emplace_back(*__first);
               :#else
               :	    push_back(*__first);
               :#endif
               :	}
               :
               :      // Called by the second initialize_dispatch above
               :      template<typename _ForwardIterator>
               :        void
               :        _M_range_initialize(_ForwardIterator __first,
               :			    _ForwardIterator __last, std::forward_iterator_tag)
               :        {
               :	  const size_type __n = std::distance(__first, __last);
               :	  this->_M_impl._M_start = this->_M_allocate(__n);
               :	  this->_M_impl._M_end_of_storage = this->_M_impl._M_start + __n;
               :	  this->_M_impl._M_finish =
               :	    std::__uninitialized_copy_a(__first, __last,
               :					this->_M_impl._M_start,
               :					_M_get_Tp_allocator());
               :	}
               :
               :      // Called by the first initialize_dispatch above and by the
               :      // vector(n,value,a) constructor.
               :      void
               :      _M_fill_initialize(size_type __n, const value_type& __value)
               :      {
               :	std::__uninitialized_fill_n_a(this->_M_impl._M_start, __n, __value, 
               :				      _M_get_Tp_allocator());
               :	this->_M_impl._M_finish = this->_M_impl._M_end_of_storage;
               :      }
               :
               :#if __cplusplus >= 201103L
               :      // Called by the vector(n) constructor.
               :      void
               :      _M_default_initialize(size_type __n)
               :      {
               :	std::__uninitialized_default_n_a(this->_M_impl._M_start, __n, 
               :					 _M_get_Tp_allocator());
               :	this->_M_impl._M_finish = this->_M_impl._M_end_of_storage;
               :      }
               :#endif
               :
               :      // Internal assign functions follow.  The *_aux functions do the actual
               :      // assignment work for the range versions.
               :
               :      // Called by the range assign to implement [23.1.1]/9
               :
               :      // _GLIBCXX_RESOLVE_LIB_DEFECTS
               :      // 438. Ambiguity in the "do the right thing" clause
               :      template<typename _Integer>
               :        void
               :        _M_assign_dispatch(_Integer __n, _Integer __val, __true_type)
               :        { _M_fill_assign(__n, __val); }
               :
               :      // Called by the range assign to implement [23.1.1]/9
               :      template<typename _InputIterator>
               :        void
               :        _M_assign_dispatch(_InputIterator __first, _InputIterator __last,
               :			   __false_type)
               :        {
               :	  typedef typename std::iterator_traits<_InputIterator>::
               :	    iterator_category _IterCategory;
               :	  _M_assign_aux(__first, __last, _IterCategory());
               :	}
               :
               :      // Called by the second assign_dispatch above
               :      template<typename _InputIterator>
               :        void
               :        _M_assign_aux(_InputIterator __first, _InputIterator __last,
               :		      std::input_iterator_tag);
               :
               :      // Called by the second assign_dispatch above
               :      template<typename _ForwardIterator>
               :        void
               :        _M_assign_aux(_ForwardIterator __first, _ForwardIterator __last,
               :		      std::forward_iterator_tag);
               :
               :      // Called by assign(n,t), and the range assign when it turns out
               :      // to be the same thing.
               :      void
               :      _M_fill_assign(size_type __n, const value_type& __val);
               :
               :
               :      // Internal insert functions follow.
               :
               :      // Called by the range insert to implement [23.1.1]/9
               :
               :      // _GLIBCXX_RESOLVE_LIB_DEFECTS
               :      // 438. Ambiguity in the "do the right thing" clause
               :      template<typename _Integer>
               :        void
               :        _M_insert_dispatch(iterator __pos, _Integer __n, _Integer __val,
               :			   __true_type)
               :        { _M_fill_insert(__pos, __n, __val); }
               :
               :      // Called by the range insert to implement [23.1.1]/9
               :      template<typename _InputIterator>
               :        void
               :        _M_insert_dispatch(iterator __pos, _InputIterator __first,
               :			   _InputIterator __last, __false_type)
               :        {
               :	  typedef typename std::iterator_traits<_InputIterator>::
               :	    iterator_category _IterCategory;
               :	  _M_range_insert(__pos, __first, __last, _IterCategory());
               :	}
               :
               :      // Called by the second insert_dispatch above
               :      template<typename _InputIterator>
               :        void
               :        _M_range_insert(iterator __pos, _InputIterator __first,
               :			_InputIterator __last, std::input_iterator_tag);
               :
               :      // Called by the second insert_dispatch above
               :      template<typename _ForwardIterator>
               :        void
               :        _M_range_insert(iterator __pos, _ForwardIterator __first,
               :			_ForwardIterator __last, std::forward_iterator_tag);
               :
               :      // Called by insert(p,n,x), and the range insert when it turns out to be
               :      // the same thing.
               :      void
               :      _M_fill_insert(iterator __pos, size_type __n, const value_type& __x);
               :
               :#if __cplusplus >= 201103L
               :      // Called by resize(n).
               :      void
               :      _M_default_append(size_type __n);
               :
               :      bool
               :      _M_shrink_to_fit();
               :#endif
               :
               :      // Called by insert(p,x)
               :#if __cplusplus < 201103L
               :      void
               :      _M_insert_aux(iterator __position, const value_type& __x);
               :#else
               :      template<typename... _Args>
               :        void
               :        _M_insert_aux(iterator __position, _Args&&... __args);
               :
               :      template<typename... _Args>
               :        void
               :        _M_emplace_back_aux(_Args&&... __args);
               :#endif
               :
               :      // Called by the latter.
               :      size_type
               :      _M_check_len(size_type __n, const char* __s) const
               :      {
               :	if (max_size() - size() < __n)
               :	  __throw_length_error(__N(__s));
               :
               :	const size_type __len = size() + std::max(size(), __n);
               :	return (__len < size() || __len > max_size()) ? max_size() : __len;
               :      }
               :
               :      // Internal erase functions follow.
               :
               :      // Called by erase(q1,q2), clear(), resize(), _M_fill_assign,
               :      // _M_assign_aux.
               :      void
               :      _M_erase_at_end(pointer __pos) _GLIBCXX_NOEXCEPT
               :      {
               :	std::_Destroy(__pos, this->_M_impl._M_finish, _M_get_Tp_allocator());
               :	this->_M_impl._M_finish = __pos;
               :      }
               :
               :      iterator
               :      _M_erase(iterator __position);
               :
               :      iterator
               :      _M_erase(iterator __first, iterator __last);
               :
               :#if __cplusplus >= 201103L
               :    private:
               :      // Constant-time move assignment when source object's memory can be
               :      // moved, either because the source's allocator will move too
               :      // or because the allocators are equal.
               :      void
               :      _M_move_assign(vector&& __x, std::true_type) noexcept
               :      {
               :	vector __tmp(get_allocator());
               :	this->_M_impl._M_swap_data(__tmp._M_impl);
               :	this->_M_impl._M_swap_data(__x._M_impl);
               :	std::__alloc_on_move(_M_get_Tp_allocator(), __x._M_get_Tp_allocator());
               :      }
               :
               :      // Do move assignment when it might not be possible to move source
               :      // object's memory, resulting in a linear-time operation.
               :      void
               :      _M_move_assign(vector&& __x, std::false_type)
               :      {
               :	if (__x._M_get_Tp_allocator() == this->_M_get_Tp_allocator())
               :	  _M_move_assign(std::move(__x), std::true_type());
               :	else
               :	  {
               :	    // The rvalue's allocator cannot be moved and is not equal,
               :	    // so we need to individually move each element.
               :	    this->assign(std::__make_move_if_noexcept_iterator(__x.begin()),
               :			 std::__make_move_if_noexcept_iterator(__x.end()));
               :	    __x.clear();
               :	  }
               :      }
               :#endif
               :
               :#if __cplusplus >= 201103L
               :      template<typename _Up>
               :	_Up*
               :	_M_data_ptr(_Up* __ptr) const
               :	{ return __ptr; }
               :
               :      template<typename _Ptr>
               :	typename std::pointer_traits<_Ptr>::element_type*
               :	_M_data_ptr(_Ptr __ptr) const
               :	{ return empty() ? nullptr : std::__addressof(*__ptr); }
               :#else
               :      template<typename _Ptr>
               :	_Ptr
               :	_M_data_ptr(_Ptr __ptr) const
               :	{ return __ptr; }
               :#endif
               :    };
               :
               :
               :  /**
               :   *  @brief  Vector equality comparison.
               :   *  @param  __x  A %vector.
               :   *  @param  __y  A %vector of the same type as @a __x.
               :   *  @return  True iff the size and elements of the vectors are equal.
               :   *
               :   *  This is an equivalence relation.  It is linear in the size of the
               :   *  vectors.  Vectors are considered equivalent if their sizes are equal,
               :   *  and if corresponding elements compare equal.
               :  */
               :  template<typename _Tp, typename _Alloc>
               :    inline bool
               :    operator==(const vector<_Tp, _Alloc>& __x, const vector<_Tp, _Alloc>& __y)
               :    { return (__x.size() == __y.size()
               :	      && std::equal(__x.begin(), __x.end(), __y.begin())); }
               :
               :  /**
               :   *  @brief  Vector ordering relation.
               :   *  @param  __x  A %vector.
               :   *  @param  __y  A %vector of the same type as @a __x.
               :   *  @return  True iff @a __x is lexicographically less than @a __y.
               :   *
               :   *  This is a total ordering relation.  It is linear in the size of the
               :   *  vectors.  The elements must be comparable with @c <.
               :   *
               :   *  See std::lexicographical_compare() for how the determination is made.
               :  */
               :  template<typename _Tp, typename _Alloc>
               :    inline bool
               :    operator<(const vector<_Tp, _Alloc>& __x, const vector<_Tp, _Alloc>& __y)
               :    { return std::lexicographical_compare(__x.begin(), __x.end(),
               :					  __y.begin(), __y.end()); }
               :
               :  /// Based on operator==
               :  template<typename _Tp, typename _Alloc>
               :    inline bool
               :    operator!=(const vector<_Tp, _Alloc>& __x, const vector<_Tp, _Alloc>& __y)
               :    { return !(__x == __y); }
               :
               :  /// Based on operator<
               :  template<typename _Tp, typename _Alloc>
               :    inline bool
               :    operator>(const vector<_Tp, _Alloc>& __x, const vector<_Tp, _Alloc>& __y)
               :    { return __y < __x; }
               :
               :  /// Based on operator<
               :  template<typename _Tp, typename _Alloc>
               :    inline bool
               :    operator<=(const vector<_Tp, _Alloc>& __x, const vector<_Tp, _Alloc>& __y)
               :    { return !(__y < __x); }
               :
               :  /// Based on operator<
               :  template<typename _Tp, typename _Alloc>
               :    inline bool
               :    operator>=(const vector<_Tp, _Alloc>& __x, const vector<_Tp, _Alloc>& __y)
               :    { return !(__x < __y); }
               :
               :  /// See std::vector::swap().
               :  template<typename _Tp, typename _Alloc>
               :    inline void
               :    swap(vector<_Tp, _Alloc>& __x, vector<_Tp, _Alloc>& __y)
               :    { __x.swap(__y); }
               :
               :_GLIBCXX_END_NAMESPACE_CONTAINER
               :} // namespace std
               :
               :#endif /* _STL_VECTOR_H */
